////////////////////////////////////////////////////////////////////////
// pageelems.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.pageelems")

// <%pre>
#line 1 "pageelems.ecpp"

#include "../services.h"

#include <livefeatures.h>
#include <setup.h>
#include <timers.h>
#include <tools.h>
#include <epg_events.h>
#include <gen_version_suffix.h>
#include <tntfeatures.h>

using namespace vdrlive;

std::string toString(const std::vector<std::string> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const std::string &str:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(str);
  }
  return result;
}
  
std::string toString(const std::vector<int> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const int &i:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(std::to_string(i) );
  }
  return result;
}
  
std::string toString(const std::vector<cActor> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const cActor &actor:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(actor.name);
    if (!actor.role.empty() ) {
      result.append(" as ");
      result.append(actor.role);
    }
  }
  return result;
}
  

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class doc_type_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        doc_type_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stylesheets_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stylesheets_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class logo_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        logo_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hide_element_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hide_element_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class progressbar_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        progressbar_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_action_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_action_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class imdb_info_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        imdb_info_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hls_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hls_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class event_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        event_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class infobox_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        infobox_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tool_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tool_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class media_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        media_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class about_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        about_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    doc_type_type doc_type;
    stylesheets_type stylesheets;
    logo_type logo;
    hide_element_type hide_element;
    progressbar_type progressbar;
    ajax_action_href_type ajax_action_href;
    imdb_info_href_type imdb_info_href;
    hls_channel_type hls_channel;
    m3u_playlist_channel_type m3u_playlist_channel;
    m3u_playlist_recording_type m3u_playlist_recording;
    event_timer_type event_timer;
    edit_timer_type edit_timer;
    ajax_js_type ajax_js;
    infobox_type infobox;
    epg_tool_box_type epg_tool_box;
    epg_tt_box_type epg_tt_box;
    media_type media;
    about_tt_box_type about_tt_box;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("pageelems");

static const char* rawData = "\340\005\000\000\341\005\000\000\343\005\000\000Q\006\000\000R\006\000\000T\006\000\000"
  "\274\006\000\000\377\016\000\000\000\017\000\000\002\017\000\000\311\017\000\000\343\017\000\000\354\017\000\000\371"
  "\017\000\000#\020\000\000J\020\000\000K\020\000\000M\020\000\000g\020\000\000h\020\000\000j\020\000\000v\020\000\000"
  "\217\020\000\000\223\020\000\000\224\020\000\000\242\020\000\000\263\020\000\000\264\020\000\000\266\020\000\000\271"
  "\020\000\000\275\020\000\000\277\020\000\000\322\020\000\000\331\020\000\000\333\020\000\000\334\020\000\000\347\020"
  "\000\000\356\020\000\000\373\020\000\000\374\020\000\000\376\020\000\000(\021\000\000*\021\000\000M\021\000\000O\021"
  "\000\000j\021\000\000s\021\000\000\177\021\000\000\200\021\000\000\202\021\000\000\245\021\000\000\261\021\000\000"
  "\272\021\000\000\306\021\000\000\307\021\000\000\311\021\000\000\353\021\000\000\367\021\000\000\000\022\000\000\014"
  "\022\000\000*\022\000\0006\022\000\000\?\022\000\000K\022\000\000L\022\000\000N\022\000\000j\022\000\000v\022\000\000"
  "\177\022\000\000\207\022\000\000\214\022\000\000\215\022\000\000\217\022\000\000\221\022\000\000\222\022\000\000\263"
  "\022\000\000\277\022\000\000\310\022\000\000\320\022\000\000\321\022\000\000\323\022\000\000\365\022\000\000\001\023"
  "\000\000\n\023\000\000\022\023\000\000\024\023\000\000\026\023\000\000\241\025\000\000\264\025\000\000\356\025\000"
  "\000\370\025\000\000\025\026\000\000\037\026\000\000Z\026\000\000^\026\000\000b\026\000\000e\026\000\000h\026\000\000"
  "k\026\000\000n\026\000\000z\026\000\000\213\026\000\000\216\026\000\000\221\026\000\000\224\026\000\000\227\026\000"
  "\000\232\026\000\000\235\026\000\000\240\026\000\000\243\026\000\000\246\026\000\000\251\026\000\000\254\026\000\000"
  "\321\026\000\000\261\027\000\000\021\030\000\000\022\030\000\000\024\030\000\000\213\030\000\000\304\031\000\000\344"
  "\031\000\000@\032\000\000E\032\000\000J\032\000\000O\032\000\000T\032\000\000\211\032\000\000\216\032\000\000\266\032"
  "\000\000\023\033\000\000=\033\000\000T\033\000\000U\033\000\000W\033\000\000X\033\000\000Z\033\000\000[\033\000\000"
  "\204\033\000\000\220\033\000\000\231\033\000\000\245\033\000\000\246\033\000\000\250\033\000\000\251\033\000\000\253"
  "\033\000\000\254\033\000\000\310\033\000\000\312\033\000\000\344\033\000\000\346\033\000\000\000\034\000\000\002\034"
  "\000\000*\034\000\0006\034\000\000\?\034\000\000J\034\000\000\200\034\000\000\232\034\000\000\234\034\000\000\266\034"
  "\000\000\270\034\000\000\322\034\000\000\325\034\000\000\330\034\000\000\331\034\000\000\341\034\000\000\342\034\000"
  "\000\344\034\000\000\006\035\000\000C\035\000\000i\035\000\000\235\035\000\000\242\035\000\000\260\035\000\000\350"
  "\035\000\000\354\035\000\000\372\035\000\0001\036\000\0006\036\000\000D\036\000\000|\036\000\000\201\036\000\000\215"
  "\036\000\000\242\036\000\000\251\036\000\000\023\037\000\000U\037\000\000h\037\000\000o\037\000\000v\037\000\000\225"
  "\037\000\000\242\037\000\000\271\037\000\000\327\037\000\000\376\037\000\000\035 \000\000= \000\000Z \000\000\210 "
  "\000\000\254 \000\000\311 \000\000\365 \000\000\031!\000\0008!\000\000m!\000\000\223!\000\000\260!\000\000\261!\000"
  "\000\337!\000\000\340!\000\000\004\"\000\000\021\"\000\000\035\"\000\000/\"\000\000E\"\000\000N\"\000\000U\"\000\000j"
  "\"\000\000k\"\000\000r\"\000\000\211\"\000\000\213\"\000\000\214\"\000\000\215\"\000\000\253\"\000\000\256\"\000\000"
  "\265\"\000\000\316\"\000\000\317\"\000\000\322\"\000\000\331\"\000\000\360\"\000\000\361\"\000\000\370\"\000\000\021#"
  "\000\000\030#\000\000\031#\000\0002#\000\0005#\000\000<#\000\000U#\000\000Z#\000\000a#\000\000\213#\000\000\236#\000"
  "\000\244#\000\000\271#\000\000\301#\000\000\310#\000\000\335#\000\000\344#\000\000\000$\000\000\t$\000\000\020$\000"
  "\000/$\000\000A$\000\000L$\000\000a$\000\000d$\000\000\200$\000\000\207$\000\000\216$\000\000\243$\000\000\250$\000"
  "\000\257$\000\000\304$\000\000\305$\000\000\310$\000\000\317$\000\000\320$\000\000\345$\000\000\356$\000\000\365$\000"
  "\000\035%\000\0000%\000\0006%\000\0007%\000\000N%\000\000W%\000\000^%\000\000u%\000\000}%\000\000\204%\000\000\205%"
  "\000\000\234%\000\000\235%\000\000\244%\000\000\273%\000\000\302%\000\000\311%\000\000\340%\000\000\351%\000\000\360%"
  "\000\000\007&\000\000\020&\000\000\027&\000\000\030&\000\0001&\000\0006&\000\000=&\000\000D&\000\000P&\000\000a&\000"
  "\000i&\000\000t&\000\000\227&\000\000\307&\000\000\316&\000\000\320&\000\000\007'\000\000\035'\000\000#'\000\000.'"
  "\000\000Q'\000\000\201'\000\000\210'\000\000\212'\000\000\301'\000\000\327'\000\000\335'\000\000\357'\000\000\365'"
  "\000\000\376'\000\000\005(\000\000\021(\000\000#(\000\000$(\000\000%(\000\000-(\000\0009(\000\000E(\000\000r(\000\000"
  "s(\000\000t(\000\000\212(\000\000\266(\000\000\333(\000\000\335(\000\000V)\000\000\275)\000\000\354)\000\000H*\000"
  "\000\255*\000\000F+\000\000\246+\000\000\004,\000\000g,\000\000\333,\000\000\n-\000\000/-\000\000R-\000\000w-\000\000"
  "\244-\000\000\002.\000\000 .\000\000$.\000\000*.\000\000,.\000\000-.\000\0003.\000\0005.\000\0006.\000\000\212.\000"
  "\000\362.\000\000\020/\000\000\024/\000\000\032/\000\000\034/\000\000\035/\000\000#/\000\000%/\000\000&/\000\000\200/"
  "\000\000\274/\000\000\353/\000\000\3330\000\000\n\n\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"htt"
  "p://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n\n\n\n<link rel=\"stylesheet\" type=\"text/css\" href=\"styles.css"
  "\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href=\"\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href=\"css/s"
  "iteprefs.css\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href=\"css/DatePicker.css\"/>\n<script type=\"text/javas"
  "cript\" src=\"js/live/header.js\"></script>\n<script type=\"text/javascript\">\nfunction classSetValue(element_id, va"
  "lue) {\n  if (document && document.getElementById(element_id) ) {\n    document.getElementById(element_id).setAttribu"
  "te(\"class\", value);\n  }\n}\nfunction removeAttributeHidden(element_id) {\n  if (document && document.getElementByI"
  "d(element_id) ) {\n    document.getElementById(element_id).removeAttribute(\"hidden\");\n    classSetValue(element_id"
  " + \"_m\", \"active\");\n  }\n}\nfunction addAttributeHidden(element_id) {\n  if (document && document.getElementById"
  "(element_id) ) {\n    document.getElementById(element_id).hidden = true;\n    classSetValue(element_id + \"_m\", \"in"
  "active\");\n  }\n}\nfunction displayOnOff(element_id_on, element_id_off) {\n removeAttributeHidden(element_id_on);\n "
  "addAttributeHidden(element_id_off);\n} \nfunction displayOn2Off(element_id_on, element_id_off1, element_id_off2) {\n "
  "removeAttributeHidden(element_id_on);\n addAttributeHidden(element_id_off1);\n addAttributeHidden(element_id_off2);\n"
  "} \nfunction displayOn3Off(element_id_on, element_id_off1, element_id_off2, element_id_off3) {\n removeAttributeHidde"
  "n(element_id_on);\n addAttributeHidden(element_id_off1);\n addAttributeHidden(element_id_off2);\n addAttributeHidden("
  "element_id_off3);\n} \nfunction displayEPG(boxId) {\n  displayOn3Off(boxId + \"_epg\", boxId + \"_scraper\", boxId + "
  "\"_actors\", boxId + \"_artwork\");\n  removeAttributeHidden(boxId + \"_epg_image\");\n}\nfunction displayScraper(box"
  "Id) {\n  displayOn3Off(boxId + \"_scraper\", boxId + \"_epg\", boxId + \"_actors\", boxId + \"_artwork\");\n  removeA"
  "ttributeHidden(boxId + \"_epg_image\");\n}\nfunction displayActors(boxId) {\n  displayOn3Off(boxId + \"_actors\", box"
  "Id + \"_epg\", boxId + \"_scraper\", boxId + \"_artwork\");\n  addAttributeHidden(boxId + \"_epg_image\");\n}\nfuncti"
  "on displayArtwork(boxId) {\n  displayOn3Off(boxId + \"_artwork\", boxId + \"_actors\", boxId + \"_epg\", boxId + \"_s"
  "craper\");\n  addAttributeHidden(boxId + \"_epg_image\");\n}\n</script>\n\n\n\n<!-- start of fixed page header -->\n<"
  "div id=\"header\" style=\"width: 100%; background-color: inherit\">\n<div id=\"padding\" style=\"display: none\"></di"
  "v>\n<div id=\"content\">\n<!-- header content follows -->\n<div class=\"page_header\">\n<a href=\"\">\n<img src=\"\" "
  "alt=\"VDR Live!\" class=\"logo\"></img></a>\n</div>\n<div style=\"clear: both\"></div>\n\n\n\nstyle=\"visibility: hid"
  "den\"\n\n\n<div class=\"\"><div class=\"__elapsed\" id=\"\"style=\"width: px\"></div></div>\n\n\n\n<a id=\"\"  href="
  "\"vdr_request/\?param=\"  ><img src=\"\" alt=\"\"></img></a> \n\n\n<a href=\"http://www.imdb.com/find\?s=all&q=\"\n<a"
  " href=\"http://www.imdb.com/title/\"\n target=\"_blank\"><img src=\"\" alt=\"\" ></img></a> \n\n\n<a href=\"stream.ht"
  "ml\?channelid_str=\"><img src=\"\" alt=\"\" ></img></a>\n\n\n\n<a href=\"playlist.m3u\?channel_str=\"><img src=\"\" a"
  "lt=\"\" ></img></a>\n<a href=\"playlist.m3u\?channel=\"><img src=\"\" alt=\"\" ></img></a>\n\n\n\n<a href=\"playlist."
  "m3u\?recid=\"><img src=\"\" alt=\"\" ></img> </a>\n\n\n\n\t\t\n\t\t<a href=\"edit_timer.html\?epgid=\"><img src=\"\" "
  "alt=\"\"  /></a>\n\n\n\n\t<a href=\"edit_timer.html\?timerid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n\n\t<script typ"
  "e=\"text/javascript\" src=\"js/mootools/mootools.v1.11.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/mo"
  "otools/DatePicker.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/liveajax.js\"></script>\n\t<script"
  " type=\"text/javascript\" src=\"js/live/infowin.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/hint"
  "tips.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/browserwin.js\"></script>\n\t<script type=\"tex"
  "t/javascript\" src=\"js/live/pageenhance.js\"></script>\n\t<script type=\"text/javascript\"><!--\n\t\tvar liveEnhance"
  "d = new PageEnhance({\n\t\t\t\tinfoWinOptions: {\n\t\t\t\t\tbuttonimg: 'img/transparent.png',\n\t\t\t\t\tloadingMsg: "
  "'',\n\t\t\t\t\terrorMsg: ''\n\t\t\t\t},\n\t\t\t\tnotifyStrings: {\n\t\t\t\t\tsuccessMsg: '<img src=\"\" alt=\"\"> ',"
  "\n\t\t\t\t\terrorMsg: '<img src=\"\" alt=\"\"> '\n\t\t\t\t},\n\t\t\t\tdatePickerOptions: '{ dayChars:2, dayNames: [\""
  "\", \"\", \"\",\"\",\"\",\"\",\"\"], format:\"\", monthNames: [\"\",\"\",\"\",\"\",\"\",\"\",\"\",\"\",\"\",\"\",\"\""
  ",\"\"],startDay:1}'\n\t\t\t});\n\t--></script>\n\t<script type=\"text/javascript\" src=\"js/live/vdr_status.js\"></sc"
  "ript>\n\t<script type=\"text/javascript\"><!--\n\t\tvar InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n\t\twindow"
  ".addEvent('domready', function(){\n\t\t\tInfoBox.request();\n\t\t});\n\t\twindow.addEvent('unload', function(){\n\t\t"
  "\tInfoBox.pageFinished();\n\t\t});\n\t--></script>\n\n\n\n<div id=\"infobox\">\n\t<div class=\"statuscontent\">\n\t\t"
  "<div class=\"st_header\">\n\t\t\t<div id=\"infobox_caption\" class=\"caption\"></div>\n\t\t\t<div id=\"infobox_timeno"
  "w\" class=\"now\">--:--</div>\n\t\t</div>\n\t\t<div class=\"st_content\">\n\t\t\t<div id=\"infobox_name\" class=\"nam"
  "e\"></div>\n\t\t\t<div id=\"infobox_duration\" class=\"duration\">--:--</div>\n\t\t</div>\n\t\t<div class=\"st_contro"
  "ls\">\n\t\t\t<div class=\"st_update\">\n\t\t\t\t<a href=\"javascript:InfoBox.toggleUpdate()\" ><img id=\"statusReload"
  "Btn\" src=\"\" alt=\"\" /></a>\n\t\t\t</div>\n\t\t\t<div id=\"infobox_recording_buttons\" style=\"display: none\">\n"
  "\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div id=\"infobox_channel_buttons\">\n\t\t\t\t"
  "\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div class=\"st_pbar\">\n\t\t\t\t\n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div style="
  "\"display: none;\">\n\t\t<span id=\"__infobox_request_err\"></span>\n\t\t<span id=\"__infobox_update_err\"></span>\n"
  "\t</div>\n</div>\n\n\n\n\t\n\t\n\t<a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\" ></img></a>\n\t"
  "\n\t\n\t\t\n\t\t<td class=\"action leftcol \"></td>\n\t\t<td class=\"action \"></td>\n\t\t<td class=\"action \"><a hr"
  "ef=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\" ></img></a><img src=\"img/transparent.png\" width=\"16"
  "\" height=\"16\"></td>\n\t\t<td class=\"action \"></td>\n\t\t<td class=\"action \"></td>\n\t\t<td class=\"action \">"
  "\n\t\t\t\n\t\t</td>\n\n\n\n\t<div class=\"epg_description\" id=\"\">\n\t\t<div class=\"station\">\n\t\t\t<div class="
  "\"boxheader\">\n\n<div>\n<div class = \"caption menu\">\n  <a id=\"_epg_m\"     class = \"active\"   onclick=\"displa"
  "yEPG('')\" ></a>\n| <a id=\"_scraper_m\" class = \"inactive\" onclick=\"displayScraper('')\"></a>\n| <a id=\"_actors_"
  "m\"  class = \"inactive\" onclick=\"displayActors('')\" ></a>\n| <a id=\"_artwork_m\" class = \"inactive\" onclick=\""
  "displayArtwork('')\" ></a>\n</div>\n<div class=\"caption\"></div>\n</div>\n                        </div>\n\t\t</div>"
  "\n\t\t<div class=\"epg_content\">\n\t\t\t<div class=\"epg_tools\">\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div class=\"epg_in"
  "fo\">\n\t\t\t\t<div class=\"info nowrap\"><span class=\"bold\"></span></div>\n\t\t\t\t<div class=\"progress\"><div></"
  "div></div>\n\t\t\t\t<div class=\"title\"></div>\n\t\t\t\t<div class=\"short\"></div>\n\t\t\t\t<div class=\"descriptio"
  "n\" id=_description>\n\t\t\t\t\t<span id = \"_epg_image\" class=\"epg_images\">\n         <a href=\"/epgimages/\" tar"
  "get=\"_blank\">\n\t\t\t\t\t\t<img src=\"/epgimages/\" class=\"epg_image\"/>\n         </a>\n         <a href=\"/tvscr"
  "aper/\" target=\"_blank\">\n\t   <img src=\"/tvscraper/\" class=\"epg_image\"/>\n         </a>\n           <a href=\""
  "/tvscraper/\" target=\"_blank\">\n             <img src=\"/tvscraper/\" class=\"epg_image\"/>\n           </a>\n     "
  "    <a href=\"/recimages//\" target=\"_blank\">\n\t\t\t\t\t\t<img src=\"/recimages//\" class=\"epg_image\"/>\n       "
  "  </a>\n\t\t\t\t\t</span>\n\n<div id = '_scraper' hidden>\n\n  <div class=\"short\">         </div>\n  <div class=\"s"
  "hort\"> </div>\n    <div class=\"short\"> SE </div>\n    <div class=\"short\">   </div>\n      <div class=\"short\"> "
  " / </div>\n    <div class=\"short\"> </div>\n      <div class=\"short\"></div>\n\n      <div class=\"short\">   </div"
  ">\n      <div class=\"short\">     </div>\n      <a href=\"https://www.imdb.com/title/\" target=\"_blank\">  </a>\n  "
  "<div class=\"short\">        </div>\n  <div class=\"short\">       </div>\n  <div class=\"short\">         </div>\n  "
  "<div class=\"short\"><a href =\"\" target=\"_blank\"></a></div>\n  <div class=\"short\">   </div>\n  <div class=\"sho"
  "rt\">       </div>\n  <div class=\"short\">     </div>\n  <div class=\"short\">  / </div>\n\n  <div class=\"short\"> "
  "        </div>\n    <a href=\"https://www.imdb.com/title/\" target=\"_blank\">  </a>\n\n    <div class=\"short\">    "
  "     </div>\n    <div class=\"short\">        </div>\n\n    <div class=\"short\"> </div>\n    <div class=\"short\">  "
  "     </div>\n    <div class=\"short\">         </div>\n    <div class=\"short\">         </div>\n\n      <div class="
  "\"short\">     </div>\n</div>\n\n<div id = '_actors' hidden>\n<table>\n      <tr>\n    <td>\n      <a href=\"/tvscrap"
  "er/\" target=\"_blank\">\n        <img src=\"/tvscraper/\" alt=\": \" width = \"118px\">\n        </img>\n      </a>"
  "\n    </td>\n      </tr>\n      <tr></tr>\n      <tr>\n    <td>\n      <a href=\"/tvscraper/\" target=\"_blank\">\n  "
  "      <img src=\"/tvscraper/\" alt=\": \" width = \"118px\">\n        </img>\n      </a>\n    </td>\n      </tr>\n   "
  "   <tr></tr>\n    </tr>\n    <tr></tr>\n</table>\n</div>\n\n<div id = '_artwork' hidden>\n\n\n\n</div>\n\n<div id = '"
  "_epg'>\n\t\t\t\t\t\t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n</div>\n\n\n  <a href=\"/tvscraper/\" target=\""
  "_blank\">\n    <img src=\"/tvscraper/\" width = \"480px\">\n    </img>\n  </a>\n\n\n\t<div class=\"epg_description\" "
  "id=\"aboutBox\">\n\t\t<div class=\"station\">\n\t\t\t<div class=\"boxheader\"><div><div class=\"caption\"></div></div"
  "></div>\n\t\t</div>\n\t\t<div class=\"epg_content\">\n\t\t\t<div>\n\t\t\t\t<div class=\"about_head\"><div><div></div>"
  "</div></div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Thomas Keil (Thomas)</div"
  ">\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Sascha Volkenandt (LordJaxom)</div>"
  "\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Markus Ehrnsperger (MarkusE @ <a href"
  "=\"https://www.vdr-portal.de\">VDR Portal</a>)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class="
  "\"about_right\">Jasmin Jessich (jasminj)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about"
  "_right\">Dieter Hametner (tadi)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">"
  "Christian Wieninger (winni)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Mich"
  "ael Br&uuml;ckner (skiller2k1)</div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div cl"
  "ass=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\"></div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t"
  "\t\t\t<div class=\"about_right\"></div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div"
  " class=\"about_left\">EPGsearch:</div>\n\t\t\t\t<div class=\"about_right\">\n\t\t\t\t\t<img align=\"center\" src=\"\""
  "/>\n\t\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"http://winni.vdr-developer.org/epgsearch/index.html\" target"
  "=\"_blank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"about_left\">Streamdev server:</div>\n\t\t\t\t<div class"
  "=\"about_right\">\n\t\t\t\t\t<img align=\"center\" src=\"\"/>\n\t\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"h"
  "ttps://projects.vdr-developer.org/projects/plg-streamdev\" target=\"_blank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div"
  " class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_line\">:<br/>\n\t\t\t\t\t<a target=\"_"
  "blank\" href=\"https://github.com/MarkusEh/vdr-plugin-live/issues\">https://github.com/MarkusEh/vdr-plugin-live/issue"
  "s</a></div>\n\t\t\t\t<div class=\"about_head\"><div><div>&nbsp;</div></div></div>\n\t\t\t</div>\n\t\t</div>\n\t</div>"
  "\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    doc_type(*this, "doc_type"),
    stylesheets(*this, "stylesheets"),
    logo(*this, "logo"),
    hide_element(*this, "hide_element"),
    progressbar(*this, "progressbar"),
    ajax_action_href(*this, "ajax_action_href"),
    imdb_info_href(*this, "imdb_info_href"),
    hls_channel(*this, "hls_channel"),
    m3u_playlist_channel(*this, "m3u_playlist_channel"),
    m3u_playlist_recording(*this, "m3u_playlist_recording"),
    event_timer(*this, "event_timer"),
    edit_timer(*this, "edit_timer"),
    ajax_js(*this, "ajax_js"),
    infobox(*this, "infobox"),
    epg_tool_box(*this, "epg_tool_box"),
    epg_tt_box(*this, "epg_tt_box"),
    media(*this, "media"),
    about_tt_box(*this, "about_tt_box")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n\n
  reply.out() << _tntChunks[3]; // \n
  reply.out() << _tntChunks[4]; // \n\n
  reply.out() << _tntChunks[7]; // \n
  reply.out() << _tntChunks[8]; // \n\n
  reply.out() << _tntChunks[15]; // \n
  reply.out() << _tntChunks[16]; // \n\n
  reply.out() << _tntChunks[18]; // \n
  reply.out() << _tntChunks[19]; // \n\n
  reply.out() << _tntChunks[26]; // \n
  reply.out() << _tntChunks[27]; // \n\n
  reply.out() << _tntChunks[38]; // \n
  reply.out() << _tntChunks[39]; // \n\n
  reply.out() << _tntChunks[47]; // \n
  reply.out() << _tntChunks[48]; // \n\n
  reply.out() << _tntChunks[53]; // \n
  reply.out() << _tntChunks[54]; // \n\n
  reply.out() << _tntChunks[63]; // \n
  reply.out() << _tntChunks[64]; // \n\n
  reply.out() << _tntChunks[70]; // \n
  reply.out() << _tntChunks[71]; // \n\n
  reply.out() << _tntChunks[78]; // \n
  reply.out() << _tntChunks[79]; // \n\n
  reply.out() << _tntChunks[84]; // \n\n
  reply.out() << _tntChunks[85]; // \n\n
  reply.out() << _tntChunks[115]; // \n
  reply.out() << _tntChunks[116]; // \n\n
  reply.out() << _tntChunks[131]; // \n
  reply.out() << _tntChunks[132]; // \n\n
  reply.out() << _tntChunks[165]; // \n
  reply.out() << _tntChunks[166]; // \n\n
  reply.out() << _tntChunks[331]; // \n
  reply.out() << _tntChunks[332]; // \n
  reply.out() << _tntChunks[336]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::doc_type_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::doc_type " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[2]; // <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stylesheets_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stylesheets " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[5]; // <link rel="stylesheet" type="text/css" href="styles.css"/>\n<link rel="stylesheet" type="text/css" href="
#line 63 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("css", "theme.css") );
  reply.out() << _tntChunks[6]; // "/>\n<link rel="stylesheet" type="text/css" href="css/siteprefs.css"/>\n<link rel="stylesheet" type="text/css" href="css/DatePicker.css"/>\n<script type="text/javascript" src="js/live/header.js"></script>\n<script type="text/javascript">\nfunction classSetValue(element_id, value) {\n  if (document && document.getElementById(element_id) ) {\n    document.getElementById(element_id).setAttribute("class", value);\n  }\n}\nfunction removeAttributeHidden(element_id) {\n  if (document && document.getElementById(element_id) ) {\n    document.getElementById(element_id).removeAttribute("hidden");\n    classSetValue(element_id + "_m", "active");\n  }\n}\nfunction addAttributeHidden(element_id) {\n  if (document && document.getElementById(element_id) ) {\n    document.getElementById(element_id).hidden = true;\n    classSetValue(element_id + "_m", "inactive");\n  }\n}\nfunction displayOnOff(element_id_on, element_id_off) {\n removeAttributeHidden(element_id_on);\n addAttributeHidden(element_id_off);\n} \nfunction displayOn2Off(element_id_on, element_id_off1, element_id_off2) {\n removeAttributeHidden(element_id_on);\n addAttributeHidden(element_id_off1);\n addAttributeHidden(element_id_off2);\n} \nfunction displayOn3Off(element_id_on, element_id_off1, element_id_off2, element_id_off3) {\n removeAttributeHidden(element_id_on);\n addAttributeHidden(element_id_off1);\n addAttributeHidden(element_id_off2);\n addAttributeHidden(element_id_off3);\n} \nfunction displayEPG(boxId) {\n  displayOn3Off(boxId + "_epg", boxId + "_scraper", boxId + "_actors", boxId + "_artwork");\n  removeAttributeHidden(boxId + "_epg_image");\n}\nfunction displayScraper(boxId) {\n  displayOn3Off(boxId + "_scraper", boxId + "_epg", boxId + "_actors", boxId + "_artwork");\n  removeAttributeHidden(boxId + "_epg_image");\n}\nfunction displayActors(boxId) {\n  displayOn3Off(boxId + "_actors", boxId + "_epg", boxId + "_scraper", boxId + "_artwork");\n  addAttributeHidden(boxId + "_epg_image");\n}\nfunction displayArtwork(boxId) {\n  displayOn3Off(boxId + "_artwork", boxId + "_actors", boxId + "_epg", boxId + "_scraper");\n  addAttributeHidden(boxId + "_epg_image");\n}\n</script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::logo_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::logo " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[9]; // <!-- start of fixed page header -->\n<div id="header" style="width: 100%; background-color: inherit">\n<div id="padding" style="display: none"></div>\n<div id="content">\n<!-- header content follows -->\n
#line 127 "pageelems.ecpp"

	if (LiveSetup().GetShowLogo()
		|| (LiveSetup().GetUseAjax() && LiveSetup().GetShowInfoBox())) {

  reply.out() << _tntChunks[10]; // <div class="page_header">\n
#line 132 "pageelems.ecpp"

		if (LiveSetup().GetShowLogo()) {

  reply.out() << _tntChunks[11]; // <a href="
#line 135 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetStartScreenLink());
  reply.out() << _tntChunks[12]; // ">\n<img src="
#line 136 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "logo.png") );
  reply.out() << _tntChunks[13]; // " alt="VDR Live!" class="logo"></img></a>\n
#line 137 "pageelems.ecpp"

		}

#line 140 "pageelems.ecpp"
if (LiveSetup().GetUseAjax() && LiveSetup().GetShowInfoBox()) { 
  // <& infobox ...
  { 
#line 140 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 140 "pageelems.ecpp"
  main().infobox(request, reply, _tnt_cq0);
    // &>
  }
#line 140 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[14]; // </div>\n<div style="clear: both"></div>\n
#line 143 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hide_element_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hide_element " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int hide = qparam.get< int >("hide", ( 1));
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 154 "pageelems.ecpp"
 if (hide) { 
  reply.out() << _tntChunks[17]; // style="visibility: hidden"
#line 154 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::progressbar_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::progressbar " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int progress = qparam.get< int >("progress", ( 0));
std::string id = qparam.get< std::string >("id");
int duration = qparam.get< int >("duration", ( -1));
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 165 "pageelems.ecpp"

	std::string cls("__progress");
	if ((duration >= 0) && ((progress < 0) || (duration == 0)))
		cls +="_invisible";

  reply.out() << _tntChunks[20]; // <div class="
#line 170 "pageelems.ecpp"
  reply.sout() << ( cls );
  reply.out() << _tntChunks[21]; // "><div class="__elapsed" 
#line 170 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[22]; // id="
#line 170 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[23]; // "
#line 170 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[24]; // style="width: 
#line 170 "pageelems.ecpp"
  reply.sout() << ( progress );
  reply.out() << _tntChunks[25]; // px"></div></div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_action_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_action_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string action = qparam.get< std::string >("action");
std::string tip = qparam.get< std::string >("tip");
std::string param = qparam.get< std::string >("param");
std::string image = qparam.get< std::string >("image");
std::string alt = qparam.get< std::string >("alt");
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 184 "pageelems.ecpp"
 { 
  reply.out() << _tntChunks[28]; // <a 
#line 184 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[29]; // id="
#line 184 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[30]; // " 
#line 184 "pageelems.ecpp"
 } 
  // <& hide_element ...
  { 
#line 184 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 184 "pageelems.ecpp"
    _tnt_cq1.add( "hide", (id.empty()? 0 : 1));
#line 184 "pageelems.ecpp"
  main().hide_element(request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[31]; //  href="vdr_request/
#line 184 "pageelems.ecpp"
  reply.sout() << ( action );
  reply.out() << _tntChunks[32]; // \?param=
#line 184 "pageelems.ecpp"
  reply.sout() << ( param );
  reply.out() << _tntChunks[33]; // " 
#line 184 "pageelems.ecpp"
if (!tip.empty()) { 
  // <& tooltip.hint ...
  { 
#line 184 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 184 "pageelems.ecpp"
    _tnt_cq2.add( "text", (tip));
#line 184 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[34]; //  
#line 184 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[35]; // ><img src="
#line 184 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", image) );
  reply.out() << _tntChunks[36]; // " alt="
#line 184 "pageelems.ecpp"
  reply.sout() << ( alt );
  reply.out() << _tntChunks[37]; // "></img></a> 
#line 184 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::imdb_info_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::imdb_info_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 194 "pageelems.ecpp"
 if (LiveSetup().GetShowIMDb()) {
if (s_IMDB_ID.empty() ) { 
  reply.out() << _tntChunks[40]; // <a href="http://www.imdb.com/find\?s=all&q=
#line 196 "pageelems.ecpp"
  reply.sout() << ( StringUrlEncode(title) );
  reply.out() << _tntChunks[41]; // "\n
#line 197 "pageelems.ecpp"
 } else { 
  reply.out() << _tntChunks[42]; // <a href="http://www.imdb.com/title/
#line 198 "pageelems.ecpp"
  reply.sout() << ( s_IMDB_ID );
  reply.out() << _tntChunks[43]; // "\n
#line 199 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[44]; //  target="_blank"><img src="
#line 200 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "imdb.png") );
  reply.out() << _tntChunks[45]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 200 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 200 "pageelems.ecpp"
    _tnt_cq3.add( "text", (tr("Find more at the Internet Movie Database.")));
#line 200 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[46]; // ></img></a> 
#line 200 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hls_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hls_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 209 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[49]; // <a href="stream.html\?channelid_str=
#line 212 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[50]; // "><img src="
#line 212 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stream_button.png") );
  reply.out() << _tntChunks[51]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 212 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 212 "pageelems.ecpp"
    _tnt_cq4.add( "text", (tr("Stream this channel into browser.")));
#line 212 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[52]; // ></img></a>\n
#line 213 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 224 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {
#if TNTVERSION >= 30000

  reply.out() << _tntChunks[55]; // <a href="playlist.m3u\?channel_str=
#line 228 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[56]; // "><img src="
#line 228 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[57]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 228 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 228 "pageelems.ecpp"
    _tnt_cq5.add( "text", (tr("Stream this channel into media player.")));
#line 228 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[58]; // ></img></a>\n
#line 229 "pageelems.ecpp"

#else

  reply.out() << _tntChunks[59]; // <a href="playlist.m3u\?channel=
#line 232 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[60]; // "><img src="
#line 232 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[61]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 232 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 232 "pageelems.ecpp"
    _tnt_cq6.add( "text", (tr("Stream this channel into media player.")));
#line 232 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[62]; // ></img></a>\n
#line 233 "pageelems.ecpp"

#endif
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 246 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
{

  reply.out() << _tntChunks[65]; // <a href="playlist.m3u\?recid=
#line 249 "pageelems.ecpp"
  reply.sout() << ( recid );
  reply.out() << _tntChunks[66]; // "><img src="
#line 249 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[67]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 249 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 249 "pageelems.ecpp"
    _tnt_cq7.add( "text", (tr("Stream this recording into media player.")));
#line 249 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[68]; // ></img> 
#line 249 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[69]; // </a>\n
#line 250 "pageelems.ecpp"

}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::event_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::event_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string epgid = qparam.get< std::string >("epgid");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 262 "pageelems.ecpp"

	tChannelID channelid;
	tEventID eventid;
	EpgEvents::DecodeDomId(epgid, channelid, eventid);
	const cTimer* timer = LiveTimerManager().GetTimer(eventid, channelid);
	if (timer) {

  reply.out() << _tntChunks[72]; // \t\t
  // <& pageelems.edit_timer ...
  { 
#line 269 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 269 "pageelems.ecpp"
    _tnt_cq8.add( "imgName", ("record_timer.png"));
#line 269 "pageelems.ecpp"
    _tnt_cq8.add( "timerId", (LiveTimerManager().GetTimers().GetTimerId(*timer)));
#line 269 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[73]; // \n
#line 270 "pageelems.ecpp"

	}
	else {

  reply.out() << _tntChunks[74]; // \t\t<a href="edit_timer.html\?epgid=
#line 274 "pageelems.ecpp"
  reply.sout() << ( epgid );
  reply.out() << _tntChunks[75]; // "><img src="
#line 274 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[76]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 274 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 274 "pageelems.ecpp"
    _tnt_cq9.add( "text", (tr("Record this")));
#line 274 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[77]; //  /></a>\n
#line 275 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::edit_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string timerId = qparam.get< std::string >("timerId");
std::string imgName = qparam.get< std::string >("imgName", ( "edit.png"));
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[80]; // \t<a href="edit_timer.html\?timerid=
#line 287 "pageelems.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timerId) );
  reply.out() << _tntChunks[81]; // "><img src="
#line 287 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", imgName) );
  reply.out() << _tntChunks[82]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 287 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 287 "pageelems.ecpp"
    _tnt_cq10.add( "text", (tr("Edit timer")));
#line 287 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[83]; //  /></a>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 294 "pageelems.ecpp"

	if (LiveSetup().GetUseAjax()) {

  reply.out() << _tntChunks[86]; // \t<script type="text/javascript" src="js/mootools/mootools.v1.11.js"></script>\n\t<script type="text/javascript" src="js/mootools/DatePicker.js"></script>\n\t<script type="text/javascript" src="js/live/liveajax.js"></script>\n\t<script type="text/javascript" src="js/live/infowin.js"></script>\n\t<script type="text/javascript" src="js/live/hinttips.js"></script>\n\t<script type="text/javascript" src="js/live/browserwin.js"></script>\n\t<script type="text/javascript" src="js/live/pageenhance.js"></script>\n\t<script type="text/javascript"><!--\n\t\tvar liveEnhanced = new PageEnhance({\n\t\t\t\tinfoWinOptions: {\n\t\t\t\t\tbuttonimg: 'img/transparent.png',\n\t\t\t\t\tloadingMsg: '
#line 308 "pageelems.ecpp"
  reply.sout() << ( tr("loading data") );
  reply.out() << _tntChunks[87]; // ',\n\t\t\t\t\terrorMsg: '
#line 309 "pageelems.ecpp"
  reply.sout() << ( tr("an error occured!") );
  reply.out() << _tntChunks[88]; // '\n\t\t\t\t},\n\t\t\t\tnotifyStrings: {\n\t\t\t\t\tsuccessMsg: '<img src="
#line 312 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "active.png") );
  reply.out() << _tntChunks[89]; // " alt=""> 
#line 312 "pageelems.ecpp"
  reply.sout() << ( tr("Request succeeded!") );
  reply.out() << _tntChunks[90]; // ',\n\t\t\t\t\terrorMsg: '<img src="
#line 313 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[91]; // " alt=""> 
#line 313 "pageelems.ecpp"
  reply.sout() << ( tr("Request failed!") );
  reply.out() << _tntChunks[92]; // '\n\t\t\t\t},\n\t\t\t\tdatePickerOptions: '{ dayChars:2, dayNames: ["
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("Sunday") );
  reply.out() << _tntChunks[93]; // ", "
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("Monday") );
  reply.out() << _tntChunks[94]; // ", "
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("Tuesday") );
  reply.out() << _tntChunks[95]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("Wednesday") );
  reply.out() << _tntChunks[96]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("Thursday") );
  reply.out() << _tntChunks[97]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("Friday") );
  reply.out() << _tntChunks[98]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("Saturday") );
  reply.out() << _tntChunks[99]; // "], format:"
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("mm/dd/yyyy") );
  reply.out() << _tntChunks[100]; // ", monthNames: ["
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("January") );
  reply.out() << _tntChunks[101]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("February") );
  reply.out() << _tntChunks[102]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("March") );
  reply.out() << _tntChunks[103]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("April") );
  reply.out() << _tntChunks[104]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("May") );
  reply.out() << _tntChunks[105]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("June") );
  reply.out() << _tntChunks[106]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("July") );
  reply.out() << _tntChunks[107]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("August") );
  reply.out() << _tntChunks[108]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("September") );
  reply.out() << _tntChunks[109]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("October") );
  reply.out() << _tntChunks[110]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("November") );
  reply.out() << _tntChunks[111]; // ","
#line 315 "pageelems.ecpp"
  reply.sout() << ( tr("December") );
  reply.out() << _tntChunks[112]; // "],startDay:1}'\n\t\t\t});\n\t--></script>\n
#line 318 "pageelems.ecpp"

		if (LiveSetup().GetShowInfoBox()) {

  reply.out() << _tntChunks[113]; // \t<script type="text/javascript" src="js/live/vdr_status.js"></script>\n\t<script type="text/javascript"><!--\n\t\tvar InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n\t\twindow.addEvent('domready', function(){\n\t\t\tInfoBox.request(
#line 325 "pageelems.ecpp"
 if (update_status) { reply.sout() << "true"; } else { reply.sout() << "false"; } 
  reply.out() << _tntChunks[114]; // );\n\t\t});\n\t\twindow.addEvent('unload', function(){\n\t\t\tInfoBox.pageFinished();\n\t\t});\n\t--></script>\n
#line 331 "pageelems.ecpp"

		}

#line 334 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::infobox_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::infobox " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[117]; // <div id="infobox">\n\t<div class="statuscontent">\n\t\t<div class="st_header">\n\t\t\t<div id="infobox_caption" class="caption">
#line 345 "pageelems.ecpp"
  reply.sout() << ( tr("retrieving status ...") );
  reply.out() << _tntChunks[118]; // </div>\n\t\t\t<div id="infobox_timenow" class="now">--:--</div>\n\t\t</div>\n\t\t<div class="st_content">\n\t\t\t<div id="infobox_name" class="name"></div>\n\t\t\t<div id="infobox_duration" class="duration">--:--</div>\n\t\t</div>\n\t\t<div class="st_controls">\n\t\t\t<div class="st_update">\n\t\t\t\t<a href="javascript:InfoBox.toggleUpdate()" 
  // <& tooltip.hint ...
  { 
#line 354 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 354 "pageelems.ecpp"
    _tnt_cq11.add( "text", (tr("Toggle updates on/off.")));
#line 354 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[119]; // ><img id="statusReloadBtn" src="
#line 354 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stop_update.png") );
  reply.out() << _tntChunks[120]; // " alt="" /></a>\n\t\t\t</div>\n\t\t\t<div id="infobox_recording_buttons" style="display: none">\n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 357 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 357 "pageelems.ecpp"
    _tnt_cq12.add( "action", ("stop_recording"));
#line 357 "pageelems.ecpp"
    _tnt_cq12.add( "id", ("infobox_stop"));
#line 357 "pageelems.ecpp"
    _tnt_cq12.add( "image", ("stop.png"));
#line 357 "pageelems.ecpp"
    _tnt_cq12.add( "tip", (tr("stop playback")));
#line 357 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[121]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 358 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 358 "pageelems.ecpp"
    _tnt_cq13.add( "action", ("play_recording"));
#line 358 "pageelems.ecpp"
    _tnt_cq13.add( "id", ("infobox_play"));
#line 358 "pageelems.ecpp"
    _tnt_cq13.add( "image", ("play.png"));
#line 358 "pageelems.ecpp"
    _tnt_cq13.add( "tip", (tr("resume playback")));
#line 358 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[122]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 359 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 359 "pageelems.ecpp"
    _tnt_cq14.add( "action", ("pause_recording"));
#line 359 "pageelems.ecpp"
    _tnt_cq14.add( "id", ("infobox_pause"));
#line 359 "pageelems.ecpp"
    _tnt_cq14.add( "image", ("pause.png"));
#line 359 "pageelems.ecpp"
    _tnt_cq14.add( "tip", (tr("pause playback")));
#line 359 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[123]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 360 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 360 "pageelems.ecpp"
    _tnt_cq15.add( "action", ("rwd_recording"));
#line 360 "pageelems.ecpp"
    _tnt_cq15.add( "id", ("infobox_rwd"));
#line 360 "pageelems.ecpp"
    _tnt_cq15.add( "image", ("rwd.png"));
#line 360 "pageelems.ecpp"
    _tnt_cq15.add( "tip", (tr("fast rewind")));
#line 360 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[124]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 361 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 361 "pageelems.ecpp"
    _tnt_cq16.add( "action", ("ffw_recording"));
#line 361 "pageelems.ecpp"
    _tnt_cq16.add( "id", ("infobox_ffw"));
#line 361 "pageelems.ecpp"
    _tnt_cq16.add( "image", ("ffw.png"));
#line 361 "pageelems.ecpp"
    _tnt_cq16.add( "tip", (tr("fast forward")));
#line 361 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[125]; // \n\t\t\t</div>\n\t\t\t<div id="infobox_channel_buttons">\n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 364 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 364 "pageelems.ecpp"
    _tnt_cq17.add( "action", ("switch_channel"));
#line 364 "pageelems.ecpp"
    _tnt_cq17.add( "id", ("infobox_prevchan"));
#line 364 "pageelems.ecpp"
    _tnt_cq17.add( "image", ("one_downarrow.png"));
#line 364 "pageelems.ecpp"
    _tnt_cq17.add( "tip", (tr("previous channel")));
#line 364 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[126]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 365 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 365 "pageelems.ecpp"
    _tnt_cq18.add( "action", ("switch_channel"));
#line 365 "pageelems.ecpp"
    _tnt_cq18.add( "id", ("infobox_nextchan"));
#line 365 "pageelems.ecpp"
    _tnt_cq18.add( "image", ("one_uparrow.png"));
#line 365 "pageelems.ecpp"
    _tnt_cq18.add( "tip", (tr("next channel")));
#line 365 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[127]; // \n\t\t\t</div>\n\t\t\t<div class="st_pbar">\n\t\t\t\t
  // <& progressbar ...
  { 
#line 368 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 368 "pageelems.ecpp"
    _tnt_cq19.add( "id", ("infobox_elapsed"));
#line 368 "pageelems.ecpp"
  main().progressbar(request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[128]; // \n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div style="display: none;">\n\t\t<span id="__infobox_request_err">
#line 373 "pageelems.ecpp"
  reply.sout() << ( tr("No server response!") );
  reply.out() << _tntChunks[129]; // </span>\n\t\t<span id="__infobox_update_err">
#line 374 "pageelems.ecpp"
  reply.sout() << ( tr("Failed to update infobox!") );
  reply.out() << _tntChunks[130]; // </span>\n\t</div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tool_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tool_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int detail = qparam.get< int >("detail");
std::string epgid = qparam.get< std::string >("epgid");
std::string title = qparam.get< std::string >("title");
time_t startTime = qparam.get< time_t >("startTime");
time_t endTime = qparam.get< time_t >("endTime");
int lastCurrentChanel = qparam.get< int >("lastCurrentChanel", ( int()));
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 391 "pageelems.ecpp"

	int duration = EpgEvents::Duration(startTime, endTime);
	int elapsed = EpgEvents::ElapsedTime(startTime, endTime);
    tEventID eventId = tEventID();
	tChannelID channelId = tChannelID();

	EpgEvents::DecodeDomId(epgid, channelId, eventId);
	if (detail) { // output for vertical toolbox

  reply.out() << _tntChunks[133]; // \t
  // <& pageelems.event_timer ...
  { 
#line 400 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 400 "pageelems.ecpp"
    _tnt_cq20.add( "epgid", (epgid));
#line 400 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[134]; // \n\t
  // <& pageelems.ajax_action_href ...
  { 
#line 401 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 401 "pageelems.ecpp"
    _tnt_cq21.add( "action", "switch_channel");
#line 401 "pageelems.ecpp"
    _tnt_cq21.add( "alt", "");
#line 401 "pageelems.ecpp"
    _tnt_cq21.add( "image", "zap.png");
#line 401 "pageelems.ecpp"
    _tnt_cq21.add( "param", (channelId));
#line 401 "pageelems.ecpp"
    _tnt_cq21.add( "tip", (tr("Switch to this channel.")));
#line 401 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[135]; // \n
#line 402 "pageelems.ecpp"

		if (LiveFeatures<features::epgsearch>().Recent() && eventId != 0) {

  reply.out() << _tntChunks[136]; // \t<a href="searchresults.html\?searchplain=
#line 405 "pageelems.ecpp"
  reply.sout() << ( StringEscapeAndBreak(title) );
  reply.out() << _tntChunks[137]; // "><img src="
#line 405 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[138]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 405 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 405 "pageelems.ecpp"
    _tnt_cq22.add( "text", (tr("Search for repeats.")));
#line 405 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[139]; // ></img></a>\n
#line 406 "pageelems.ecpp"

		}
		if ((duration == 0) || (elapsed >= 0)) {

  reply.out() << _tntChunks[140]; // \t
  // <& pageelems.hls_channel ...
  { 
#line 410 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 410 "pageelems.ecpp"
    _tnt_cq23.add( "channelId", (channelId));
#line 410 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[141]; // \n\t
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 411 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 411 "pageelems.ecpp"
    _tnt_cq24.add( "channelId", (channelId));
#line 411 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[142]; // \n
#line 412 "pageelems.ecpp"

		}
	if (eventId != 0) {

  reply.out() << _tntChunks[143]; // \t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 416 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 416 "pageelems.ecpp"
    _tnt_cq25.add( "s_IMDB_ID", (s_IMDB_ID));
#line 416 "pageelems.ecpp"
    _tnt_cq25.add( "title", (title));
#line 416 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[144]; // \n
#line 417 "pageelems.ecpp"

		}
	}
	else { // table output

  reply.out() << _tntChunks[145]; // \t\t<td class="action leftcol 
#line 422 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[146]; // ">
  // <& pageelems.event_timer ...
  { 
#line 422 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 422 "pageelems.ecpp"
    _tnt_cq26.add( "epgid", (epgid));
#line 422 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[147]; // </td>\n\t\t<td class="action 
#line 423 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[148]; // ">
  // <& pageelems.ajax_action_href ...
  { 
#line 423 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq27;
#line 423 "pageelems.ecpp"
    _tnt_cq27.add( "action", "switch_channel");
#line 423 "pageelems.ecpp"
    _tnt_cq27.add( "alt", "");
#line 423 "pageelems.ecpp"
    _tnt_cq27.add( "image", "zap.png");
#line 423 "pageelems.ecpp"
    _tnt_cq27.add( "param", (channelId));
#line 423 "pageelems.ecpp"
    _tnt_cq27.add( "tip", (tr("Switch to this channel.")));
#line 423 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq27);
    // &>
  }
  reply.out() << _tntChunks[149]; // </td>\n\t\t<td class="action 
#line 424 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[150]; // ">
#line 424 "pageelems.ecpp"
if (LiveFeatures<features::epgsearch>().Recent() && eventId != 0) { 
  reply.out() << _tntChunks[151]; // <a href="searchresults.html\?searchplain=
#line 424 "pageelems.ecpp"
  reply.sout() << ( StringUrlEncode(title) );
  reply.out() << _tntChunks[152]; // "><img src="
#line 424 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[153]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 424 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq28;
#line 424 "pageelems.ecpp"
    _tnt_cq28.add( "text", (tr("Search for repeats.")));
#line 424 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq28);
    // &>
  }
  reply.out() << _tntChunks[154]; // ></img></a>
#line 424 "pageelems.ecpp"
 } else { 
  reply.out() << _tntChunks[155]; // <img src="img/transparent.png" width="16" height="16">
#line 424 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[156]; // </td>\n\t\t<td class="action 
#line 425 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[157]; // ">
#line 425 "pageelems.ecpp"
if ((duration == 0) || (elapsed > 0)) { 
  // <& pageelems.hls_channel ...
  { 
#line 425 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq29;
#line 425 "pageelems.ecpp"
    _tnt_cq29.add( "channelId", (channelId));
#line 425 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq29);
    // &>
  }
#line 425 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[158]; // </td>\n\t\t<td class="action 
#line 426 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[159]; // ">
#line 426 "pageelems.ecpp"
if ((duration == 0) || (elapsed > 0)) { 
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 426 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq30;
#line 426 "pageelems.ecpp"
    _tnt_cq30.add( "channelId", (channelId));
#line 426 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq30);
    // &>
  }
#line 426 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[160]; // </td>\n\t\t<td class="action 
#line 427 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[161]; // ">\n
#line 428 "pageelems.ecpp"

			if (eventId != 0) {

  reply.out() << _tntChunks[162]; // \t\t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 431 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq31;
#line 431 "pageelems.ecpp"
    _tnt_cq31.add( "title", (title));
#line 431 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq31);
    // &>
  }
  reply.out() << _tntChunks[163]; // \n
#line 432 "pageelems.ecpp"

			}

  reply.out() << _tntChunks[164]; // \t\t</td>\n
#line 436 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string boxId = qparam.get< std::string >("boxId");
std::string caption = qparam.get< std::string >("caption");
std::string tools_comp = qparam.get< std::string >("tools_comp");
std::string time = qparam.get< std::string >("time");
std::string title = qparam.get< std::string >("title");
std::string short_descr = qparam.get< std::string >("short_descr");
std::string long_descr = qparam.get< std::string >("long_descr");
std::string filename = qparam.get< std::string >("filename");
std::string archived = qparam.get< std::string >("archived");
std::string epgImage = qparam.get< std::string >("epgImage");
uintptr_t ievent = qparam.get< uintptr_t >("ievent");
uintptr_t irecording = qparam.get< uintptr_t >("irecording");
int elapsed = qparam.get< int >("elapsed", ( -1));
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[167]; // \t<div class="epg_description" id="
#line 459 "pageelems.ecpp"
  reply.sout() << ( (boxId) );
  reply.out() << _tntChunks[168]; // ">\n\t\t<div class="station">\n\t\t\t<div class="boxheader">\n\n<div>\n
#line 464 "pageelems.ecpp"

cScraperMovieOrTv scraperMovieOrTv;
scraperMovieOrTv.found = false;
scraperMovieOrTv.event = static_cast<cEvent *>((void *)ievent);
scraperMovieOrTv.recording = static_cast<cRecording *>((void *)irecording);
scraperMovieOrTv.httpImagePaths = false;
scraperMovieOrTv.media = true;
ScraperCallService("GetScraperMovieOrTv", &scraperMovieOrTv);
const bool episodeFound = scraperMovieOrTv.found && (!scraperMovieOrTv.movie) && scraperMovieOrTv.episodeFound;
if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[169]; // <div class = "caption menu">\n  <a id="
#line 476 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[170]; // _epg_m"     class = "active"   onclick="displayEPG('
#line 476 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[171]; // ')" >
#line 476 "pageelems.ecpp"
  reply.sout() << ( trVDR("EPG") );
  reply.out() << _tntChunks[172]; // </a>\n| <a id="
#line 477 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[173]; // _scraper_m" class = "inactive" onclick="displayScraper('
#line 477 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[174]; // ')">
#line 477 "pageelems.ecpp"
  reply.sout() << ( tr("Scraper") );
  reply.out() << _tntChunks[175]; // </a>\n| <a id="
#line 478 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[176]; // _actors_m"  class = "inactive" onclick="displayActors('
#line 478 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[177]; // ')" >
#line 478 "pageelems.ecpp"
  reply.sout() << ( tr("Actors") );
  reply.out() << _tntChunks[178]; // </a>\n| <a id="
#line 479 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[179]; // _artwork_m" class = "inactive" onclick="displayArtwork('
#line 479 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[180]; // ')" >
#line 479 "pageelems.ecpp"
  reply.sout() << ( tr("Artwork") );
  reply.out() << _tntChunks[181]; // </a>\n</div>\n
#line 481 "pageelems.ecpp"

} else {

  reply.out() << _tntChunks[182]; // <div class="caption">
#line 484 "pageelems.ecpp"
  reply.sout() << ( (caption) );
  reply.out() << _tntChunks[183]; // </div>\n
#line 485 "pageelems.ecpp"

}

  reply.out() << _tntChunks[184]; // </div>\n                        </div>\n\t\t</div>\n\t\t<div class="epg_content">\n\t\t\t<div class="epg_tools">\n\t\t\t\t
  // <& (tools_comp) ...
  { 
#line 493 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq32;
#line 493 "pageelems.ecpp"
    _tnt_cq32.add( "archived", (archived));
#line 493 "pageelems.ecpp"
    _tnt_cq32.add( "detail", (1));
#line 493 "pageelems.ecpp"
    _tnt_cq32.add( "id", (boxId));
#line 493 "pageelems.ecpp"
    _tnt_cq32.add( "s_IMDB_ID", (scraperMovieOrTv.IMDB_ID));
#line 493 "pageelems.ecpp"
    _tnt_cq32.add( "title", (title));
#line 493 "pageelems.ecpp"
    callComp((tools_comp), request, reply, _tnt_cq32);
    // &>
  }
  reply.out() << _tntChunks[185]; // \n\t\t\t</div>\n\t\t\t<div class="epg_info">\n\t\t\t\t<div class="info nowrap">
#line 496 "pageelems.ecpp"
 if (!archived.empty()) { 
  reply.out() << _tntChunks[186]; // <span class="bold">
#line 496 "pageelems.ecpp"
  reply.sout() << ( (archived + " ") );
  reply.out() << _tntChunks[187]; // </span>
#line 496 "pageelems.ecpp"
 } 
#line 496 "pageelems.ecpp"
  reply.sout() << ( (time) );
  reply.out() << _tntChunks[188]; // </div>\n
#line 497 "pageelems.ecpp"

	if (elapsed >= 0) {

  reply.out() << _tntChunks[189]; // \t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 500 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq33;
#line 500 "pageelems.ecpp"
    _tnt_cq33.add( "progress", (elapsed));
#line 500 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq33);
    // &>
  }
  reply.out() << _tntChunks[190]; // </div></div>\n
#line 501 "pageelems.ecpp"

	}

  reply.out() << _tntChunks[191]; // \t\t\t\t<div class="title">
#line 504 "pageelems.ecpp"
  reply.sout() << ( (title) );
  reply.out() << _tntChunks[192]; // </div>\n\t\t\t\t<div class="short">
#line 505 "pageelems.ecpp"
  reply.sout() << ( (short_descr) );
  reply.out() << _tntChunks[193]; // </div>\n\t\t\t\t<div class="description" id=
#line 506 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[194]; // _description>\n\t\t\t\t\t<span id = "
#line 507 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[195]; // _epg_image" class="epg_images">\n
#line 508 "pageelems.ecpp"

	std::list<std::string> images = EpgEvents::EpgImages(boxId);
	for(std::list<std::string>::iterator it = images.begin(); it != images.end(); ++it ) {

  reply.out() << _tntChunks[196]; //          <a href="/epgimages/
#line 512 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[197]; // " target="_blank">\n\t\t\t\t\t\t<img src="/epgimages/
#line 513 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[198]; // " class="epg_image"/>\n         </a>\n
#line 515 "pageelems.ecpp"

	}
        if(!epgImage.empty() ) {

  reply.out() << _tntChunks[199]; //          <a href="/tvscraper/
#line 519 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[200]; // " target="_blank">\n\t   <img src="/tvscraper/
#line 520 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[201]; // " class="epg_image"/>\n         </a>\n
#line 522 "pageelems.ecpp"

          if (episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty() ) {

  reply.out() << _tntChunks[202]; //            <a href="/tvscraper/
#line 525 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(scraperMovieOrTv.episode.episodeImage.path) );
  reply.out() << _tntChunks[203]; // " target="_blank">\n             <img src="/tvscraper/
#line 526 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(scraperMovieOrTv.episode.episodeImage.path) );
  reply.out() << _tntChunks[204]; // " class="epg_image"/>\n           </a>\n
#line 528 "pageelems.ecpp"

          }
	} else {

	std::list<std::string> images1 = EpgEvents::RecImages(boxId, filename);
	size_t delimPos = boxId.find_last_of('_');
	std::string recId = (delimPos)?boxId.substr(delimPos+1):boxId;

	for(std::list<std::string>::iterator it = images1.begin(); it != images1.end(); ++it ) {

  reply.out() << _tntChunks[205]; //          <a href="/recimages/
#line 538 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[206]; // /
#line 538 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[207]; // " target="_blank">\n\t\t\t\t\t\t<img src="/recimages/
#line 539 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[208]; // /
#line 539 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[209]; // " class="epg_image"/>\n         </a>\n
#line 541 "pageelems.ecpp"

	}}

  reply.out() << _tntChunks[210]; // \t\t\t\t\t</span>\n
  reply.out() << _tntChunks[211]; // \n<div id = '
#line 546 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[212]; // _scraper' hidden>\n
#line 547 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[213]; // \n  <div class="short">
#line 553 "pageelems.ecpp"
  reply.sout() << ( tr("Title:") );
  reply.out() << _tntChunks[214]; //          
#line 553 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.title ) );
  reply.out() << _tntChunks[215]; // </div>\n
#line 554 "pageelems.ecpp"

  if (!scraperMovieOrTv.originalTitle.empty() ) {

  reply.out() << _tntChunks[216]; //   <div class="short">
#line 557 "pageelems.ecpp"
  reply.sout() << ( tr("Original title:") );
  reply.out() << _tntChunks[217]; //  
#line 557 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.originalTitle ) );
  reply.out() << _tntChunks[218]; // </div>\n
#line 558 "pageelems.ecpp"

  }
  if (episodeFound) {

  reply.out() << _tntChunks[219]; //     <div class="short">
#line 562 "pageelems.ecpp"
  reply.sout() << ( tr("Episode:") );
  reply.out() << _tntChunks[220]; //  S
#line 562 "pageelems.ecpp"
  reply.sout() << ( std::to_string(scraperMovieOrTv.episode.season ) );
  reply.out() << _tntChunks[221]; // E
#line 562 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.number ) );
#line 562 "pageelems.ecpp"
  reply.sout() << (scraperMovieOrTv.episode.absoluteNumber?"A" + std::to_string(scraperMovieOrTv.episode.absoluteNumber):"");
  reply.out() << _tntChunks[222]; //  
#line 562 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.name ) );
  reply.out() << _tntChunks[223]; // </div>\n    <div class="short">
#line 563 "pageelems.ecpp"
  reply.sout() << ( tr("Episode overview:") );
  reply.out() << _tntChunks[224]; //    
#line 563 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.overview ) );
  reply.out() << _tntChunks[225]; // </div>\n
#line 564 "pageelems.ecpp"

    if (scraperMovieOrTv.episode.vote_average != 0 ) {

  reply.out() << _tntChunks[226]; //       <div class="short">
#line 567 "pageelems.ecpp"
  reply.sout() << ( tr("Episode vote average/count:") );
  reply.out() << _tntChunks[227]; //  
#line 567 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_average ) );
  reply.out() << _tntChunks[228]; //  / 
#line 567 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_count ) );
  reply.out() << _tntChunks[229]; // </div>\n
#line 568 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[230]; //     <div class="short">
#line 571 "pageelems.ecpp"
  reply.sout() << ( tr("Episode first aired:") );
  reply.out() << _tntChunks[231]; //  
#line 571 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.firstAired ) );
  reply.out() << _tntChunks[232]; // </div>\n
#line 572 "pageelems.ecpp"

    if (!scraperMovieOrTv.episode.guestStars.empty() ) {

  reply.out() << _tntChunks[233]; //       <div class="short">
#line 575 "pageelems.ecpp"
  reply.sout() << ( tr("Episode guest stars:") );
#line 575 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.episode.guestStars) );
  reply.out() << _tntChunks[234]; // </div>\n
#line 576 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[235]; // \n
#line 582 "pageelems.ecpp"

    if (!scraperMovieOrTv.episode.director.empty() ) {

  reply.out() << _tntChunks[236]; //       <div class="short">
#line 585 "pageelems.ecpp"
  reply.sout() << ( tr("Episode director:") );
  reply.out() << _tntChunks[237]; //    
#line 585 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.episode.director) );
  reply.out() << _tntChunks[238]; // </div>\n
#line 586 "pageelems.ecpp"

    }
    if (!scraperMovieOrTv.episode.writer.empty() ) {

  reply.out() << _tntChunks[239]; //       <div class="short">
#line 590 "pageelems.ecpp"
  reply.sout() << ( tr("Episode writer:") );
  reply.out() << _tntChunks[240]; //      
#line 590 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.episode.writer) );
  reply.out() << _tntChunks[241]; // </div>\n
#line 591 "pageelems.ecpp"

    }
    if (!scraperMovieOrTv.episode.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[242]; //       <a href="https://www.imdb.com/title/
#line 595 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.IMDB_ID ) );
  reply.out() << _tntChunks[243]; // " target="_blank"> 
#line 595 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB episode") );
  reply.out() << _tntChunks[244]; //  </a>\n
#line 596 "pageelems.ecpp"

    }
  }  // end if episode found
  if (!scraperMovieOrTv.tagline.empty() ) {

  reply.out() << _tntChunks[245]; //   <div class="short">
#line 601 "pageelems.ecpp"
  reply.sout() << ( tr("Tagline:") );
  reply.out() << _tntChunks[246]; //         
#line 601 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.tagline ) );
  reply.out() << _tntChunks[247]; // </div>\n
#line 602 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[248]; //   <div class="short">
#line 605 "pageelems.ecpp"
  reply.sout() << ( tr("Overview:") );
  reply.out() << _tntChunks[249]; //        
#line 605 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.overview ) );
  reply.out() << _tntChunks[250]; // </div>\n  <div class="short">
#line 606 "pageelems.ecpp"
  reply.sout() << ( tr("Genres:") );
  reply.out() << _tntChunks[251]; //          
#line 606 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.genres ) );
  reply.out() << _tntChunks[252]; // </div>\n
#line 607 "pageelems.ecpp"

  if (!scraperMovieOrTv.homepage.empty() ) {

  reply.out() << _tntChunks[253]; //   <div class="short"><a href ="
#line 610 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.homepage) );
  reply.out() << _tntChunks[254]; // " target="_blank">
#line 610 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[255]; // </a></div>\n
#line 611 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[256]; //   <div class="short">
#line 614 "pageelems.ecpp"
  reply.sout() << ( tr("Release date:") );
  reply.out() << _tntChunks[257]; //    
#line 614 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.releaseDate ) );
  reply.out() << _tntChunks[258]; // </div>\n  <div class="short">
#line 615 "pageelems.ecpp"
  reply.sout() << ( tr("Runtimes:") );
  reply.out() << _tntChunks[259]; //        
#line 615 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.runtimes ) );
  reply.out() << _tntChunks[260]; // </div>\n
#line 616 "pageelems.ecpp"

  if (scraperMovieOrTv.popularity != 0) {

  reply.out() << _tntChunks[261]; //   <div class="short">
#line 619 "pageelems.ecpp"
  reply.sout() << ( tr("Popularity:") );
  reply.out() << _tntChunks[262]; //      
#line 619 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.popularity ) );
  reply.out() << _tntChunks[263]; // </div>\n
#line 620 "pageelems.ecpp"

  }
  if (scraperMovieOrTv.voteAverage  != 0) {

  reply.out() << _tntChunks[264]; //   <div class="short">
#line 624 "pageelems.ecpp"
  reply.sout() << ( tr("Vote average/count:") );
  reply.out() << _tntChunks[265]; //  
#line 624 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteAverage ) );
  reply.out() << _tntChunks[266]; //  / 
#line 624 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteCount ) );
  reply.out() << _tntChunks[267]; // </div>\n
#line 625 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[268]; // \n
#line 631 "pageelems.ecpp"

  if (!scraperMovieOrTv.actors.empty() ) {

  reply.out() << _tntChunks[269]; //   <div class="short">
#line 634 "pageelems.ecpp"
  reply.sout() << ( tr("Actors:") );
  reply.out() << _tntChunks[270]; //          
#line 634 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.actors) );
  reply.out() << _tntChunks[271]; // </div>\n
#line 635 "pageelems.ecpp"

  }
  if (!scraperMovieOrTv.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[272]; //     <a href="https://www.imdb.com/title/
#line 639 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.IMDB_ID ) );
  reply.out() << _tntChunks[273]; // " target="_blank"> 
#line 639 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB") );
  reply.out() << _tntChunks[274]; //  </a>\n
#line 640 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[275]; // \n
#line 647 "pageelems.ecpp"

  if (scraperMovieOrTv.movie) {
    if (scraperMovieOrTv.budget) {

  reply.out() << _tntChunks[276]; //     <div class="short">
#line 651 "pageelems.ecpp"
  reply.sout() << ( tr("Budget:") );
  reply.out() << _tntChunks[277]; //          
#line 651 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.budget ) );
  reply.out() << _tntChunks[278]; // </div>\n
#line 652 "pageelems.ecpp"

    }
    if (scraperMovieOrTv.revenue) {

  reply.out() << _tntChunks[279]; //     <div class="short">
#line 656 "pageelems.ecpp"
  reply.sout() << ( tr("Revenue:") );
  reply.out() << _tntChunks[280]; //         
#line 656 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.revenue) );
  reply.out() << _tntChunks[281]; // </div>\n
#line 657 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[282]; // \n
#line 663 "pageelems.ecpp"

    if (!scraperMovieOrTv.collectionName.empty() ) {

  reply.out() << _tntChunks[283]; //     <div class="short">
#line 666 "pageelems.ecpp"
  reply.sout() << ( tr("Collection name:") );
  reply.out() << _tntChunks[284]; //  
#line 666 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.collectionName) );
  reply.out() << _tntChunks[285]; // </div>\n
#line 667 "pageelems.ecpp"

    }
    if (!scraperMovieOrTv.director.empty() ) {

  reply.out() << _tntChunks[286]; //     <div class="short">
#line 671 "pageelems.ecpp"
  reply.sout() << ( tr("Director:") );
  reply.out() << _tntChunks[287]; //        
#line 671 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.director) );
  reply.out() << _tntChunks[288]; // </div>\n
#line 672 "pageelems.ecpp"

    }
    if (!scraperMovieOrTv.writer.empty() ) {

  reply.out() << _tntChunks[289]; //     <div class="short">
#line 676 "pageelems.ecpp"
  reply.sout() << ( tr("Writer:") );
  reply.out() << _tntChunks[290]; //          
#line 676 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.writer) );
  reply.out() << _tntChunks[291]; // </div>\n
#line 677 "pageelems.ecpp"

    }
  } else {  // TV show

  reply.out() << _tntChunks[292]; //     <div class="short">
#line 681 "pageelems.ecpp"
  reply.sout() << ( tr("Status:") );
  reply.out() << _tntChunks[293]; //          
#line 681 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.status    ) );
  reply.out() << _tntChunks[294]; // </div>\n
  reply.out() << _tntChunks[295]; // \n
#line 685 "pageelems.ecpp"

    if (!scraperMovieOrTv.createdBy.empty() ) {

  reply.out() << _tntChunks[296]; //       <div class="short">
#line 688 "pageelems.ecpp"
  reply.sout() << ( tr("Created by:") );
  reply.out() << _tntChunks[297]; //      
#line 688 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.createdBy) );
  reply.out() << _tntChunks[298]; // </div>\n
#line 689 "pageelems.ecpp"

    }
  }
}

  reply.out() << _tntChunks[299]; // </div>\n
  reply.out() << _tntChunks[300]; // \n<div id = '
#line 696 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[301]; // _actors' hidden>\n
#line 697 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[302]; // <table>\n
#line 701 "pageelems.ecpp"

  const int num_cols = 4;
  int num = 1;
  std::string actor_names = "";
  for (cActor &actor: scraperMovieOrTv.actors) {
    if (actor.actorThumb.path.empty() ) continue;  // only actors with images
    if (num == 1) {

  reply.out() << _tntChunks[303]; //       <tr>\n
#line 710 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[304]; //     <td>\n      <a href="/tvscraper/
#line 714 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(actor.actorThumb.path) );
  reply.out() << _tntChunks[305]; // " target="_blank">\n        <img src="/tvscraper/
#line 715 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(actor.actorThumb.path) );
  reply.out() << _tntChunks[306]; // " alt="
#line 715 "pageelems.ecpp"
  reply.sout() << (actor.name);
  reply.out() << _tntChunks[307]; // : 
#line 715 "pageelems.ecpp"
  reply.sout() << (actor.role);
  reply.out() << _tntChunks[308]; // " width = "118px">\n        </img>\n      </a>\n    </td>\n
#line 719 "pageelems.ecpp"

    actor_names.append("<td>"); 
    actor_names.append(actor.name); 
    actor_names.append(":<br>"); 
    actor_names.append(actor.role); 
    actor_names.append("</td>"); 
    if (num == num_cols) {

  reply.out() << _tntChunks[309]; //       </tr>\n      <tr>
#line 728 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[310]; // </tr>\n
#line 729 "pageelems.ecpp"

      num = 0;
      actor_names = "";
    }
    num++;
  } // for actor in actors
  if (episodeFound) for (cActor &actor: scraperMovieOrTv.episode.guestStars) {
    if (actor.actorThumb.path.empty() ) continue;  // only actors with images
    if (num == 1) {

  reply.out() << _tntChunks[311]; //       <tr>\n
#line 740 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[312]; //     <td>\n      <a href="/tvscraper/
#line 744 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(actor.actorThumb.path) );
  reply.out() << _tntChunks[313]; // " target="_blank">\n        <img src="/tvscraper/
#line 745 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(actor.actorThumb.path) );
  reply.out() << _tntChunks[314]; // " alt="
#line 745 "pageelems.ecpp"
  reply.sout() << (actor.name);
  reply.out() << _tntChunks[315]; // : 
#line 745 "pageelems.ecpp"
  reply.sout() << (actor.role);
  reply.out() << _tntChunks[316]; // " width = "118px">\n        </img>\n      </a>\n    </td>\n
#line 749 "pageelems.ecpp"

    actor_names.append("<td>"); 
    actor_names.append(actor.name); 
    actor_names.append(":<br>"); 
    actor_names.append(actor.role); 
    actor_names.append("</td>"); 
    if (num == num_cols) {

  reply.out() << _tntChunks[317]; //       </tr>\n      <tr>
#line 758 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[318]; // </tr>\n
#line 759 "pageelems.ecpp"

      num = 0;
    }
    num++;
  } // for actor in episode.guestStars
  if (num != 1) {

  reply.out() << _tntChunks[319]; //     </tr>\n    <tr>
#line 767 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[320]; // </tr>\n
#line 768 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[321]; // </table>\n
#line 772 "pageelems.ecpp"

}

  reply.out() << _tntChunks[322]; // </div>\n
  reply.out() << _tntChunks[323]; // \n<div id = '
#line 777 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[324]; // _artwork' hidden>\n
#line 778 "pageelems.ecpp"

  const uintptr_t media_p = (uintptr_t)&(scraperMovieOrTv.posters);
  const uintptr_t media_b = (uintptr_t)&(scraperMovieOrTv.banners);
  const uintptr_t media_f = (uintptr_t)&(scraperMovieOrTv.fanarts);

  // <& media ...
  { 
#line 783 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq34;
#line 783 "pageelems.ecpp"
    _tnt_cq34.add( "media_p", (media_p));
#line 783 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq34);
    // &>
  }
  reply.out() << _tntChunks[325]; // \n
  // <& media ...
  { 
#line 784 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq35;
#line 784 "pageelems.ecpp"
    _tnt_cq35.add( "media_p", (media_f));
#line 784 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq35);
    // &>
  }
  reply.out() << _tntChunks[326]; // \n
  // <& media ...
  { 
#line 785 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq36;
#line 785 "pageelems.ecpp"
    _tnt_cq36.add( "media_p", (media_b));
#line 785 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq36);
    // &>
  }
  reply.out() << _tntChunks[327]; // \n</div>\n
  reply.out() << _tntChunks[328]; // \n<div id = '
#line 788 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[329]; // _epg'>\n\t\t\t\t\t
#line 789 "pageelems.ecpp"
 reply.out() << StringEscapeAndBreak(long_descr); 
  reply.out() << _tntChunks[330]; // \t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::media_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::media " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t media_p = qparam.get< uintptr_t >("media_p");
  // </%args>

#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 802 "pageelems.ecpp"

const std::vector<cTvMedia> *media_v = static_cast<std::vector<cTvMedia> *>((void *)media_p);
for (const cTvMedia &media: *media_v) {

  reply.out() << _tntChunks[333]; //   <a href="/tvscraper/
#line 806 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(media.path) );
  reply.out() << _tntChunks[334]; // " target="_blank">\n    <img src="/tvscraper/
#line 807 "pageelems.ecpp"
  reply.sout() << ( ScraperImagePath2Live(media.path) );
  reply.out() << _tntChunks[335]; // " width = "480px">\n    </img>\n  </a>\n
#line 810 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::about_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::about_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 50 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[337]; // \t<div class="epg_description" id="aboutBox">\n\t\t<div class="station">\n\t\t\t<div class="boxheader"><div><div class="caption">
#line 819 "pageelems.ecpp"
  reply.sout() << ( tr(LIVESUMMARY) );
  reply.out() << _tntChunks[338]; // </div></div></div>\n\t\t</div>\n\t\t<div class="epg_content">\n\t\t\t<div>\n\t\t\t\t<div class="about_head"><div><div>
#line 823 "pageelems.ecpp"
  reply.sout() << ( tr("Authors") );
  reply.out() << _tntChunks[339]; // </div></div></div>\n\t\t\t\t<div class="about_left">
#line 824 "pageelems.ecpp"
  reply.sout() << ( tr("Project Idea") );
  reply.out() << _tntChunks[340]; // :</div>\n\t\t\t\t<div class="about_right">Thomas Keil (Thomas)</div>\n\t\t\t\t<div class="about_left">
#line 826 "pageelems.ecpp"
  reply.sout() << ( tr("Webserver") );
  reply.out() << _tntChunks[341]; // :</div>\n\t\t\t\t<div class="about_right">Sascha Volkenandt (LordJaxom)</div>\n\t\t\t\t<div class="about_left">
#line 828 "pageelems.ecpp"
  reply.sout() << ( tr("Current Maintainer") );
  reply.out() << _tntChunks[342]; // :</div>\n\t\t\t\t<div class="about_right">Markus Ehrnsperger (MarkusE @ <a href="https://www.vdr-portal.de">VDR Portal</a>)</div>\n\t\t\t\t<div class="about_left">
#line 830 "pageelems.ecpp"
  reply.sout() << ( tr("Previous Maintainer") );
  reply.out() << _tntChunks[343]; // :</div>\n\t\t\t\t<div class="about_right">Jasmin Jessich (jasminj)</div>\n\t\t\t\t<div class="about_left">
#line 832 "pageelems.ecpp"
  reply.sout() << ( tr("Project leader") );
  reply.out() << _tntChunks[344]; // :</div>\n\t\t\t\t<div class="about_right">Dieter Hametner (tadi)</div>\n\t\t\t\t<div class="about_left">
#line 834 "pageelems.ecpp"
  reply.sout() << ( tr("Content") );
  reply.out() << _tntChunks[345]; // :</div>\n\t\t\t\t<div class="about_right">Christian Wieninger (winni)</div>\n\t\t\t\t<div class="about_left">
#line 836 "pageelems.ecpp"
  reply.sout() << ( tr("Graphics") );
  reply.out() << _tntChunks[346]; // :</div>\n\t\t\t\t<div class="about_right">Michael Br&uuml;ckner (skiller2k1)</div>\n\t\t\t\t<div class="about_head"><div><div>
#line 838 "pageelems.ecpp"
  reply.sout() << ( tr("Information") );
  reply.out() << _tntChunks[347]; // </div></div></div>\n\t\t\t\t<div class="about_left">
#line 839 "pageelems.ecpp"
  reply.sout() << ( tr("LIVE version") );
  reply.out() << _tntChunks[348]; // :</div>\n\t\t\t\t<div class="about_right">
#line 840 "pageelems.ecpp"
  reply.sout() << ( LIVEVERSION );
#line 840 "pageelems.ecpp"
  reply.sout() << ( VERSION_SUFFIX );
  reply.out() << _tntChunks[349]; // </div>\n\t\t\t\t<div class="about_left">
#line 841 "pageelems.ecpp"
  reply.sout() << ( tr("VDR version") );
  reply.out() << _tntChunks[350]; // :</div>\n\t\t\t\t<div class="about_right">
#line 842 "pageelems.ecpp"
  reply.sout() << ( VDRVERSION );
  reply.out() << _tntChunks[351]; // </div>\n\t\t\t\t<div class="about_head"><div><div>
#line 843 "pageelems.ecpp"
  reply.sout() << ( tr("Features") );
  reply.out() << _tntChunks[352]; // </div></div></div>\n\t\t\t\t<div class="about_left">EPGsearch:</div>\n\t\t\t\t<div class="about_right">\n
#line 846 "pageelems.ecpp"

					Features< features::epgsearch >& epgsearch = LiveFeatures< features::epgsearch >();

  reply.out() << _tntChunks[353]; // \t\t\t\t\t<img align="center" src="
#line 849 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", epgsearch.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[354]; // "/>\n
#line 850 "pageelems.ecpp"

					if ( epgsearch.Recent() ) {

  reply.out() << _tntChunks[355]; // \t\t\t\t\t\t
#line 853 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[356]; // : 
#line 853 "pageelems.ecpp"
  reply.sout() << ( epgsearch.Version() );
  reply.out() << _tntChunks[357]; // \n
#line 854 "pageelems.ecpp"

					} else {

  reply.out() << _tntChunks[358]; // \t\t\t\t\t\t
#line 857 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[359]; // : 
#line 857 "pageelems.ecpp"
  reply.sout() << ( epgsearch.MinVersion() );
  reply.out() << _tntChunks[360]; // \n
#line 858 "pageelems.ecpp"

					}

  reply.out() << _tntChunks[361]; // \t\t\t\t\t(<a href="http://winni.vdr-developer.org/epgsearch/index.html" target="_blank">
#line 861 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[362]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_left">Streamdev server:</div>\n\t\t\t\t<div class="about_right">\n
#line 865 "pageelems.ecpp"

					Features< features::streamdev_server >& streamdev = LiveFeatures< features::streamdev_server >();

  reply.out() << _tntChunks[363]; // \t\t\t\t\t<img align="center" src="
#line 868 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", streamdev.Loaded() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[364]; // "/>\n
#line 869 "pageelems.ecpp"

					if ( streamdev.Loaded() ) {

  reply.out() << _tntChunks[365]; // \t\t\t\t\t\t
#line 872 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[366]; // : 
#line 872 "pageelems.ecpp"
  reply.sout() << ( streamdev.Version() );
  reply.out() << _tntChunks[367]; // \n
#line 873 "pageelems.ecpp"

					} else {

  reply.out() << _tntChunks[368]; // \t\t\t\t\t\t
#line 876 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[369]; // : 
#line 876 "pageelems.ecpp"
  reply.sout() << ( streamdev.MinVersion() );
  reply.out() << _tntChunks[370]; // \n
#line 877 "pageelems.ecpp"

					}

  reply.out() << _tntChunks[371]; // \t\t\t\t\t(<a href="https://projects.vdr-developer.org/projects/plg-streamdev" target="_blank">
#line 880 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[372]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_head"><div><div>
#line 882 "pageelems.ecpp"
  reply.sout() << ( tr("Bugs and suggestions") );
  reply.out() << _tntChunks[373]; // </div></div></div>\n\t\t\t\t<div class="about_line">
#line 883 "pageelems.ecpp"
  reply.sout() << ( tr("If you encounter any bugs or would like to suggest new features, please use our bugtracker") );
  reply.out() << _tntChunks[374]; // :<br/>\n\t\t\t\t\t<a target="_blank" href="https://github.com/MarkusEh/vdr-plugin-live/issues">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n\t\t\t\t<div class="about_head"><div><div>&nbsp;</div></div></div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
