////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <setup.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>
#ifdef HAVE_PCRE2
#include <StringMatch.h>
#endif
#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!
#include <string>
std::string argList;
std::string recoring_item;
size_t max_length_recoring_item = 0;

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    delete_error_type delete_error;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "x\001\000\000y\001\000\000z\001\000\000{\001\000\000\237\001\000\000\252\001\000\000\255"
  "\001\000\000i\002\000\000\277\010\000\000\300\010\000\000\302\010\000\000\303\010\000\000\305\010\000\000\306\010\000"
  "\000\001\t\000\000\024\t\000\000\027\t\000\000\030\t\000\000\256\t\000\000\004\n\000\000#\n\000\000=\n\000\000>\n\000"
  "\000\?\n\000\000A\n\000\000\266\n\000\000\334\n\000\000\361\n\000\000\035\013\000\000L\013\000\000n\013\000\000\250"
  "\013\000\000\267\013\000\000\331\013\000\000\033\014\000\000\035\014\000\000i\014\000\000|\014\000\000\255\014\000"
  "\000\275\014\000\000\277\014\000\000\302\014\000\000\303\014\000\000\304\014\000\000\306\014\000\000\337\014\000\000"
  "\022\015\000\000\026\015\000\000`\015\000\000d\015\000\000\264\015\000\000\270\015\000\000\275\015\000\000\004\016"
  "\000\000\010\016\000\000\015\016\000\000A\016\000\000p\016\000\000\250\016\000\000\260\016\000\000\353\016\000\000"
  "\364\016\000\000\031\017\000\000\"\017\000\000,\017\000\000-\017\000\000/\017\000\000N\017\000\000P\017\000\000[\017"
  "\000\000j\017\000\000k\017\000\000m\017\000\000\220\017\000\000\234\017\000\000\245\017\000\000\254\017\000\000\255"
  "\017\000\000\260\017\000\000\261\017\000\000\262\017\000\000\263\017\000\000\264\017\000\000\265\017\000\000\266\017"
  "\000\000\270\017\000\000\302\017\000\000\321\017\000\000\325\017\000\000\326\017\000\000\327\017\000\000\331\017\000"
  "\000\333\017\000\000\334\017\000\000\n\n\n\n<html>\n\t<head>\n\t\t<title>VDR-Live - </title>\n\t\t\n\t\t\n\t\t<script"
  " type=\"text/javascript\" src=\"treeview.js\"></script>\n\t\t<script type=\"text/javascript\"><!--\n\t\tfunction filt"
  "erRecordings(filter)\n\t\t{\n\t\t\twindow.location.href = \"recordings.html\?sort=&filter=\" + encodeURIComponent(fil"
  "ter.value);\n\t\t}\n\t\tfunction ExpandAll()\n\t\t{\n\t\t\tvar openNodes = \"\";\n\t\t\trecordingNodes = window.docum"
  "ent.getElementsBySelector(\"ul.recordingslist\");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t"
  "\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'blo"
  "ck';\n\t\t\t\t\topenNodes += recordingNodes[idx].id + \",\"; \n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.documen"
  "t.getElementsBySelector(\"img.recording_expander\");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t"
  "\texpandNodes[idx].src = \"img/minus.png\";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector(\"img"
  ".recording_folder\");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = \"img/f"
  "older_open.png\";\n\t\t\t}\n\t\t\tcreateCookie( cookieNameRec, openNodes, 14 );\n\t\t}\n\t\tfunction CollapseAll()\n"
  "\t\t{\n\t\t\trecordingNodes = window.document.getElementsBySelector(\"ul.recordingslist\");\n\t\t\tfor (idx = 0; idx "
  "< recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t"
  "\trecordingNodes[idx].style.display = 'none';\n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsByS"
  "elector(\"img.recording_expander\");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx"
  "].src = \"img/plus.png\";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector(\"img.recording_folder"
  "\");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = \"img/folder_closed.png"
  "\";\n\t\t\t}\n\t\t\teraseCookie( cookieNameRec );\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload=\"adjustHeade"
  "r()\" onresize=\"adjustHeader()\">\n\t\t\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<div class=\"boxheader\"><div"
  "><div></div></div></div>\n\t\t\t\n\t\t\t<form method=\"post\" name=\"recordings\" action=\"recordings.ecpp\">\n\t\t\t"
  "<div class=\"recordings\">\n\t\t\t<ul class=\"recordingslist\" style=\"display: block;\">\n\n\t\t\t</ul>\n\t\t\t</div"
  ">\n\t\t\t<div class=\"withmargin\">\n\t\t\t\t<button class=\"red\" type=\"submit\"></button>\n\t\t\t</div>\n\t\t\t</f"
  "orm>\n\t\t</div>\n\t</body>\n</html>\n\n\n\n\n\t<li class=\"recording\">\n  <div class=\"recording_item\" onclick=\"T"
  "oggle(this)\">\n    <div class=\"recording_imgs\">\n      <img src=\"img/transparent.png\" width=\"px\" height=\"16px"
  "\" /> \n      <img class=\"recording_expander\" src=\"plus.png\" /><img class=\"recording_folder\" src=\"folder_close"
  "d.png\" /></div>\n      \n        <div class=\"thumb\">\n        <img src=\"/tvscraper/\"\n             \n        />"
  "\n        </div>\n       \n    <div class=\"recording_spec\">\n      <div class=\"recording_name\"></div>\n    </div>"
  "\n    <div class=\"recording_actions\">&nbsp;</div>\n  </div>\n\n      <ul id=\"fldr_\" class=\"recordingslist\" styl"
  "e=\"display: none;\">\n\n\t\t</ul>\n\t</li>\n  \n  \n\n\n\n<span class=\"label bold\"> </span>\n<a href=\"recordings."
  "html\?sort=name&filter=\" /></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=date&filter=\" /></a>"
  "\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=duplicates&filter=\" /></a>\n<span class=\"sep\">|</s"
  "pan>\n<a href=\"recordings.html\?sort=errors&filter=\" /></a>\n<span class=\"sep\">|</span>\n<span class=\"label bold"
  "\">:&nbsp;<input type=\"text\" name=\"filter\" value=\"\" id=\"filter\" onchange=\"filterRecordings(this)\" />&nbsp;<"
  "/span>\n<span class=\"sep\">|</span>\n<img onclick=\"ExpandAll()\" src=\"\" alt=\"\" />\n<img onclick=\"CollapseAll()"
  "\" src=\"\" alt=\"\" />\n<br />\n\n\n\n<a href=\"recordings.html\?todel=\" ><img src=\"\" alt=\"\" /></a>\n\n\n<a hre"
  "f=\"edit_recording.html\?recid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n\n\n\n\n\n\n\n\n<img src=\"\" alt=\"on_dvd\" "
  " />\n\n\n\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string sort = qparam.get< std::string >("sort");
std::string todel = qparam.get< std::string >("todel");
std::string diskinfo = qparam.get< std::string >("diskinfo");
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > deletions = qparam.getvector< std::string >("deletions");
std::string flat = qparam.get< std::string >("flat");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 44 "recordings.ecpp"

if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

// sort depends on old sort, an sort parameter
currentSort = LiveSetup().GetLastSortingMode();
if (currentSort.empty() ) currentSort = "nameasc";
if (!sort.empty()) {
	if (sort == "date")
		currentSort = (currentSort == "dateasc") ? "datedesc" : "dateasc";
	else if (sort == "name")
		currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
	else if (sort == "errors")
                currentSort = (currentSort == "errorsasc") ? "errorsdesc" : "errorsasc";
	else if (sort == "duplicates")
		currentSort = sort;
	else if (sort == "tvShowsMovies")
		currentSort = sort;
	LiveSetup().SetLastSortingMode(currentSort);
}
// flat defaults from sort, but can we overwritten
if (currentSort == "errorsasc" || currentSort == "errorsdesc" || currentSort == "duplicates") currentFlat = "true";
  else currentFlat = "false";
if (! flat.empty() ) currentFlat = flat;

currentFilter = filter;

pageTitle = tr("Recordings");

deleteResult = "";
if (!todel.empty()) {
	if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
	deletions.push_back(todel);
}
#if TNTVERSION >= 30000
typedef std::vector<std::string> deletions_type;
#endif
for (deletions_type::const_iterator it = deletions.begin(); it != deletions.end(); ++it) {
	if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
		RemoveRecordingTask task(*it);
		LiveTaskManager().Execute(task);
		if (!task.Result())
			deleteResult += std::string() + tr("ERROR:") + " " + task.Error() + "<br/>";
		else
			deleteResult += std::string() + tr("Deleted recording:") + " " + StringReplace(task.RecName(), "~", "/") + "<br/>";
	}
	else {
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
	}
}
deletions.clear();

int FreeMB, UsedMB;
#if APIVERSNUM > 20101
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
#else
int Percent = VideoDiskSpace(&FreeMB, &UsedMB);
#endif
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));

  // <& pageelems.doc_type ...
  { 
#line 107 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 107 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n\t<head>\n\t\t<title>VDR-Live - 
#line 110 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[4]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 111 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 111 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 112 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 112 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n\t\t<script type="text/javascript" src="treeview.js"></script>\n\t\t<script type="text/javascript"><!--\n\t\tfunction filterRecordings(filter)\n\t\t{\n\t\t\twindow.location.href = "recordings.html\?sort=
#line 117 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[7]; // &filter=" + encodeURIComponent(filter.value);\n\t\t}\n\t\tfunction ExpandAll()\n\t\t{\n\t\t\tvar openNodes = "";\n\t\t\trecordingNodes = window.document.getElementsBySelector("ul.recordingslist");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'block';\n\t\t\t\t\topenNodes += recordingNodes[idx].id + ","; \n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector("img.recording_expander");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = "img/minus.png";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector("img.recording_folder");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = "img/folder_open.png";\n\t\t\t}\n\t\t\tcreateCookie( cookieNameRec, openNodes, 14 );\n\t\t}\n\t\tfunction CollapseAll()\n\t\t{\n\t\t\trecordingNodes = window.document.getElementsBySelector("ul.recordingslist");\n\t\t\tfor (idx = 0; idx < recordingNodes.length; idx++) {\n\t\t\t\tif (recordingNodes[idx].parentNode.className != 'recordings') {\n\t\t\t\t\trecordingNodes[idx].style.display = 'none';\n\t\t\t\t}\n\t\t\t}\n\t\t\texpandNodes = window.document.getElementsBySelector("img.recording_expander");\n\t\t\tfor (idx = 0; idx < expandNodes.length; idx++) {\n\t\t\t\texpandNodes[idx].src = "img/plus.png";\n\t\t\t}\n\t\t\tfolderNodes = window.document.getElementsBySelector("img.recording_folder");\n\t\t\tfor (idx = 0; idx < folderNodes.length; idx++) {\n\t\t\t\tfolderNodes[idx].src = "img/folder_closed.png";\n\t\t\t}\n\t\t\teraseCookie( cookieNameRec );\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 160 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 160 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[8]; // \n
#line 161 "recordings.ecpp"

if (!deleteResult.empty()) {

  reply.out() << _tntChunks[9]; // \t\t
  // <& menu ...
  { 
#line 164 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 164 "recordings.ecpp"
    _tnt_cq4.add( "active", ("recordings"));
#line 164 "recordings.ecpp"
    _tnt_cq4.add( "component", ("recordings.delete_error"));
#line 164 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[10]; // \n
#line 165 "recordings.ecpp"

} else {

  reply.out() << _tntChunks[11]; // \t\t
  // <& menu ...
  { 
#line 168 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 168 "recordings.ecpp"
    _tnt_cq5.add( "active", ("recordings"));
#line 168 "recordings.ecpp"
    _tnt_cq5.add( "component", ("recordings.sort_options"));
#line 168 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[12]; // \n
#line 169 "recordings.ecpp"

}

  reply.out() << _tntChunks[13]; // \t\t<div class="inhalt">\n\t\t\t<div class="boxheader"><div><div>
#line 173 "recordings.ecpp"
  reply.sout() << ( std::string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << _tntChunks[14]; // </div></div></div>\n
#line 174 "recordings.ecpp"

#if VDRVERSNUM >= 20301
			int rec_cnt;
			{
				LOCK_RECORDINGS_READ;
				rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
			}
			if (rec_cnt == 0) {
#else
			if (Recordings.Count() == 0) { // Access VDRs global cRecordings Recordings instance.
#endif

  reply.out() << _tntChunks[15]; // \t\t\t
#line 186 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << _tntChunks[16]; // \n
#line 187 "recordings.ecpp"

			} else {

  reply.out() << _tntChunks[17]; // \t\t\t<form method="post" name="recordings" action="recordings.ecpp">\n\t\t\t<div class="recordings">\n\t\t\t<ul class="recordingslist" style="display: block;">\n
  // <& recordings.recordings_item ...
  { 
#line 193 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 193 "recordings.ecpp"
    _tnt_cq6.add( "filter", (currentFilter));
#line 193 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[18]; // \n\t\t\t</ul>\n\t\t\t</div>\n\t\t\t<div class="withmargin">\n\t\t\t\t<button class="red" type="submit">
#line 197 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << _tntChunks[19]; // </button>\n\t\t\t</div>\n\t\t\t</form>\n
#line 200 "recordings.ecpp"

			}

  reply.out() << _tntChunks[20]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[21]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[22]; // \n
  reply.out() << _tntChunks[23]; // \n\n
  reply.out() << _tntChunks[42]; // \n
  reply.out() << _tntChunks[43]; // \n\n
  reply.out() << _tntChunks[64]; // \n
  reply.out() << _tntChunks[65]; // \n\n
  reply.out() << _tntChunks[70]; // \n
  reply.out() << _tntChunks[71]; // \n\n
  reply.out() << _tntChunks[76]; // \n
  reply.out() << _tntChunks[77]; // \n\n\n
  reply.out() << _tntChunks[83]; // \n
  reply.out() << _tntChunks[84]; // \n\n
  reply.out() << _tntChunks[89]; // \n
  reply.out() << _tntChunks[90]; // \n\n
  reply.out() << _tntChunks[91]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string filter = qparam.get< std::string >("filter");
int counter = qparam.get< int >("counter", ( 0));
uintptr_t iRecItem = qparam.get< uintptr_t >("iRecItem", ( 0));
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 216 "recordings.ecpp"

recoring_item.reserve(6000);
// Max Buffer used: 5.636 bytes
RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());
RecordingsItemPtr recItemThisDir;
if (iRecItem != 0) {
recItemThisDir = *(static_cast<RecordingsItemPtr *>((void *)iRecItem) );
} else {
recItemThisDir = recordingsTree->get(std::vector<std::string>() );
}
std::list<RecordingsItemPtr> recItems;
std::list<RecordingsItemPtr>::iterator recIter;
bool sorted = false;
int level = 0;
if( currentFlat != "true" ) {
sorted = recItemThisDir->addSubdirs(recItems);
if (!sorted) {
  if (currentSort == "namedesc")
          recItems.sort(RecordingsItemPtrCompare::ByDescendingNameDescSort);
  else if (currentSort == "nameasc")
          recItems.sort(RecordingsItemPtrCompare::ByAscendingNameDescSort);
}
for (recIter = recItems.begin(); recIter != recItems.end(); ++recIter) {
	RecordingsItemPtr recItem = *recIter;
	counter++;

	/* search trough directory for new recordings */
        bool newR = false;
	if ( LiveSetup().GetMarkNewRec() ) newR = recItem->checkNew();
        level = recItem->Level();

  reply.out() << _tntChunks[24]; // \t<li class="recording">\n  <div class="recording_item" onclick="Toggle(this)">\n    <div class="recording_imgs">\n      
#line 250 "recordings.ecpp"
 if(level > 1) { 
  reply.out() << _tntChunks[25]; // <img src="img/transparent.png" width="
#line 250 "recordings.ecpp"
  reply.sout() << (16*(level-1) );
  reply.out() << _tntChunks[26]; // px" height="16px" /> 
#line 250 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[27]; // \n      <img class="recording_expander" src="
#line 251 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[28]; // plus.png" /><img class="recording_folder" src="
#line 251 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[29]; // folder_closed.png" /></div>\n      
#line 252 "recordings.ecpp"
 if (!recItem->scraperImage().path.empty() ) { 
  reply.out() << _tntChunks[30]; // \n        <div class="thumb">\n        <img src="/tvscraper/
#line 254 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().path );
  reply.out() << _tntChunks[31]; // "\n             
#line 255 "recordings.ecpp"
  reply.out() << ( recItem->scraperImage().width > recItem->scraperImage().height?"class=\"thumb\"":"class=\"thumbpt\"" );
  reply.out() << _tntChunks[32]; // \n        />\n        </div>\n       
#line 258 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[33]; // \n    <div class="recording_spec">\n      <div class="recording_name
#line 260 "recordings.ecpp"
  reply.sout() << ( (newR ? "_new" : "") );
  reply.out() << _tntChunks[34]; // ">
#line 260 "recordings.ecpp"
  reply.sout() << ( recItem->Name() );
  reply.out() << _tntChunks[35]; // </div>\n    </div>\n    <div class="recording_actions">&nbsp;</div>\n  </div>\n\n
#line 265 "recordings.ecpp"

      std::string combinedId = recItem->Name() + "_";
      combinedId += counter + "_" + recItem->Level();
      std::string idHash(MD5Hash(combinedId));
      iRecItem = (uintptr_t)&recItem;

  reply.out() << _tntChunks[36]; //       <ul id="fldr_
#line 271 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[37]; // " class="recordingslist" style="display: none;">\n
  // <& recordings.recordings_item ...
  { 
#line 272 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 272 "recordings.ecpp"
    _tnt_cq7.add( "counter", (counter));
#line 272 "recordings.ecpp"
    _tnt_cq7.add( "filter", (filter));
#line 272 "recordings.ecpp"
    _tnt_cq7.add( "iRecItem", (iRecItem));
#line 272 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[38]; // \n\t\t</ul>\n\t</li>\n
#line 275 "recordings.ecpp"

}
recItems.clear();
sorted = recItemThisDir->addRecordings(recItems);
level = recItemThisDir->Level() + 1;
} else {
if (currentSort == "duplicates") {
  addAllDuplicateRecordings(recItems, recordingsTree);
} else {
  recordingsTree->addAllRecordings(recItems);
}
}
if (!sorted) {
  if (currentSort == "dateasc")
          recItems.sort(RecordingsItemPtrCompare::ByAscendingDate);
  else if (currentSort == "datedesc")
          recItems.sort(RecordingsItemPtrCompare::ByDescendingDate);
  else if (currentSort == "namedesc")
          recItems.sort(RecordingsItemPtrCompare::ByDescendingNameDescSort);
  else if (currentSort == "nameasc")
          recItems.sort(RecordingsItemPtrCompare::ByAscendingNameDescSort);
  else if (currentSort == "errorsasc" || currentSort == "errorsdesc")
          recItems.sort(RecordingsItemPtrCompare::ByDescendingRecordingErrors);
}

argList.clear();
argList.append("&sort=");
argList.append(currentSort);
argList.append("&filter=");
argList.append(currentFilter);
for (recIter = recItems.begin(); recIter != recItems.end(); ++recIter) {
		RecordingsItemPtr recItem = *recIter;
  recoring_item.clear();
  recItem->AppendasHtml(recoring_item, currentFlat == "true", argList, level);
  max_length_recoring_item = std::max(max_length_recoring_item, recoring_item.length() );
#ifdef HAVE_PCRE2
  StringMatch sm(filter);
  if (filter.empty() or
      sm.Matches(recItem->Name()) or
      sm.Matches(recItem->ShortText()?recItem->ShortText() : "" ) or
      sm.Matches(recItem->Description()?recItem->Description() : ""))
#endif
		{

  reply.out() << _tntChunks[39]; //   
#line 319 "recordings.ecpp"
  reply.out() << ( recoring_item );
  reply.out() << _tntChunks[40]; // \n  
  reply.out() << _tntChunks[41]; // \n
#line 322 "recordings.ecpp"

		}
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 331 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[44]; // <span class="label bold">
#line 332 "recordings.ecpp"
  reply.sout() << ( tr("Sort:") );
  reply.out() << _tntChunks[45]; //  </span>\n<a href="recordings.html\?sort=name&filter=
#line 333 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[46]; // " />
#line 333 "recordings.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << _tntChunks[47]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=date&filter=
#line 335 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[48]; // " />
#line 335 "recordings.ecpp"
  reply.sout() << ( tr("Date") );
  reply.out() << _tntChunks[49]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=duplicates&filter=
#line 337 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[50]; // " />
#line 337 "recordings.ecpp"
  reply.sout() << ( tr("Duplicates") );
  reply.out() << _tntChunks[51]; // </a>\n
#line 338 "recordings.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[52]; // <span class="sep">|</span>\n<a href="recordings.html\?sort=errors&filter=
#line 342 "recordings.ecpp"
  if ( currentFilter != "" )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[53]; // " />
#line 342 "recordings.ecpp"
  reply.sout() << ( tr("Errors") );
  reply.out() << _tntChunks[54]; // </a>\n
#line 343 "recordings.ecpp"

#endif
#ifdef HAVE_PCRE2

  reply.out() << _tntChunks[55]; // <span class="sep">|</span>\n<span class="label bold">
#line 348 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << _tntChunks[56]; // :&nbsp;<input type="text" name="filter" value="
#line 348 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[57]; // " id="filter" onchange="filterRecordings(this)" />&nbsp;
  // <& tooltip.help ...
  { 
#line 348 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 348 "recordings.ecpp"
    _tnt_cq8.add( "text", (tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")));
#line 348 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[58]; // </span>\n
#line 349 "recordings.ecpp"

#endif

  reply.out() << _tntChunks[59]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" src="
#line 353 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "plus.png") );
  reply.out() << _tntChunks[60]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 353 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 353 "recordings.ecpp"
    _tnt_cq9.add( "text", (tr("Expand all folders")));
#line 353 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[61]; // />\n<img onclick="CollapseAll()" src="
#line 354 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "minus.png") );
  reply.out() << _tntChunks[62]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 354 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 354 "recordings.ecpp"
    _tnt_cq10.add( "text", (tr("Collapse all folders")));
#line 354 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[63]; // />\n<br />\n
#line 356 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 365 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[66]; // <a href="recordings.html\?todel=
#line 365 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[67]; // " 
  // <& tooltip.hint ...
  { 
#line 365 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 365 "recordings.ecpp"
    _tnt_cq11.add( "text", (tr("Delete this recording from hard disc!")));
#line 365 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[68]; // ><img src="
#line 365 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[69]; // " alt="" /></a>
#line 365 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 374 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[72]; // <a href="edit_recording.html\?recid=
#line 374 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[73]; // "><img src="
#line 374 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[74]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 374 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 374 "recordings.ecpp"
    _tnt_cq12.add( "text", (tr("Edit recording")));
#line 374 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[75]; //  /></a>
#line 374 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& pageelems.ajax_action_href ...
  { 
#line 386 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 386 "recordings.ecpp"
    _tnt_cq13.add( "action", "play_recording");
#line 386 "recordings.ecpp"
    _tnt_cq13.add( "alt", "");
#line 386 "recordings.ecpp"
    _tnt_cq13.add( "image", "play.png");
#line 386 "recordings.ecpp"
    _tnt_cq13.add( "param", (id));
#line 386 "recordings.ecpp"
    _tnt_cq13.add( "tip", (tr("play this recording.")));
#line 386 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[78]; // \n
  // <& pageelems.m3u_playlist_recording ...
  { 
#line 387 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 387 "recordings.ecpp"
    _tnt_cq14.add( "recid", (id));
#line 387 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_recording"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[79]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 388 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 388 "recordings.ecpp"
    _tnt_cq15.add( "s_IMDB_ID", (s_IMDB_ID));
#line 388 "recordings.ecpp"
    _tnt_cq15.add( "title", (title));
#line 388 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[80]; // \n
  // <& recordings.edit_rec ...
  { 
#line 389 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 389 "recordings.ecpp"
    _tnt_cq16.add( "id", (id));
#line 389 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[81]; // \n
  // <& recordings.del_rec ...
  { 
#line 390 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 390 "recordings.ecpp"
    _tnt_cq17.add( "id", (id));
#line 390 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[82]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string archived = qparam.get< std::string >("archived");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[85]; // <img src="
#line 401 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[86]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 401 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 401 "recordings.ecpp"
    _tnt_cq18.add( "text", (archived));
#line 401 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[87]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 402 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 402 "recordings.ecpp"
    _tnt_cq19.add( "s_IMDB_ID", (s_IMDB_ID));
#line 402 "recordings.ecpp"
    _tnt_cq19.add( "title", (title));
#line 402 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[88]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 32 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 37 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 38 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 39 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 40 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 410 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 410 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[92]; // \n
#line 411 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return DEFAULT;
}

} // namespace
